import _Input from "antd/es/input";
import _TreeSelect from "antd/es/tree-select";
import _Switch from "antd/es/switch";
import _Select from "antd/es/select";
import _DatePicker from "antd/es/date-picker";
import _InputNumber from "antd/es/input-number";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["onChange", "formatter"];
import locale from 'antd/es/date-picker/locale/zh_CN';
import { isNumber } from 'lodash';
import dayjs from 'dayjs';
import React, { useEffect, useState } from 'react';
import "./styles.less";
export default function Index(props) {
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    cellValue = _useState2[0],
    setCellValue = _useState2[1];
  //@ts-ignore
  var _props$cellEvent = props.cellEvent,
    value = _props$cellEvent.value,
    node = _props$cellEvent.node,
    colDef = _props$cellEvent.colDef,
    rowIndex = _props$cellEvent.rowIndex;
  //@ts-ignore
  var cellEditorParams = colDef.cellEditorParams,
    field = colDef.field;
  var key = "".concat(rowIndex, "_").concat(field);
  // 使用的组件类型
  var cellEditorType = colDef.cellEditor;
  useEffect(function () {
    if (value !== cellValue) {
      setCellValue(value);
    }
  }, [value]);
  var getRendererParams = function getRendererParams(params) {
    switch (cellEditorType) {
      case 'extNumericEditor':
        return params.antdInputNumberProps;
        break;
      case 'extSelectEditor':
        return params.antdSelectProps;
        break;
      case 'extSwitchEditor':
        return params.antdSwitchProps;
        break;
      case 'extTreeSelectEditor':
        return params.antdTreeSelectProps;
        break;
      default:
        break;
    }
    return params || {};
  };
  var updateCellData = function updateCellData(val) {
    setCellValue(val);
    node.setDataValue(colDef.field, val);
  };
  var _getRendererParams = getRendererParams(cellEditorParams),
    _onChange = _getRendererParams.onChange,
    _getRendererParams$fo = _getRendererParams.formatter,
    formatter = _getRendererParams$fo === void 0 ? 'YYYY-MM-DD HH:mm' : _getRendererParams$fo,
    otherProps = _objectWithoutProperties(_getRendererParams, _excluded);
  var cellEditorModule;
  switch (cellEditorType) {
    case 'extNumericEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_InputNumber, _extends({
        "data-key": key,
        size: "small",
        onChange: function onChange(e) {
          if (isNumber(e)) {
            updateCellData(e);
            _onChange === null || _onChange === void 0 || _onChange(e);
          } else {
            updateCellData('');
            _onChange === null || _onChange === void 0 || _onChange('');
          }
        },
        value: cellValue
      }, otherProps));
      break;
    case 'extDateEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_DatePicker, _extends({
        "data-key": key,
        locale: locale,
        style: {
          width: '100%'
        },
        formatter: formatter,
        value: cellValue ? dayjs(cellValue) : '',
        onChange: function onChange(e) {
          //@ts-ignore
          var value = e ? dayjs(e).format(formatter) : '';
          updateCellData(value);
          _onChange === null || _onChange === void 0 || _onChange(value);
        }
      }, otherProps));
      break;
    case 'extSelectEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_Select, _extends({
        "data-key": key,
        onChange: function onChange(e) {
          updateCellData(e);
          _onChange === null || _onChange === void 0 || _onChange(e);
        },
        value: cellValue,
        size: "small",
        style: {
          width: '100%'
        },
        showSearch: true
      }, otherProps));
      break;
    case 'extSwitchEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_Switch, _extends({
        checked: cellValue,
        onChange: function onChange(checked) {
          updateCellData(checked);
          _onChange === null || _onChange === void 0 || _onChange(checked);
        }
      }, otherProps));
      break;
    case 'extTreeSelectEditor':
      cellEditorModule = /*#__PURE__*/React.createElement(_TreeSelect, _extends({
        "data-key": key,
        onChange: function onChange(e) {
          updateCellData(e);
          _onChange === null || _onChange === void 0 || _onChange(e);
        },
        value: cellValue,
        size: "small",
        style: {
          width: '100%'
        },
        showSearch: true
      }, otherProps));
      break;
    default:
      cellEditorModule = /*#__PURE__*/React.createElement(_Input, _extends({
        "data-key": key,
        size: "small",
        onChange: function onChange(e) {
          updateCellData(e.target.value);
        },
        value: cellValue
      }, otherProps));
      break;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-cellEdit"
  }, cellEditorModule);
}