import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
/*
 * @Author: chenzenghua
 * @Date: 2023-03-23 13:07:24
 * @LastEditTime: 2024-01-03 19:05:50
 * @LastEditors: chenzenghua
 * @Description:
 */

import dayjs from 'dayjs';
import React, { forwardRef, memo, useEffect, useImperativeHandle, useRef, useState } from 'react';
import XDatePicker from "../../../XDatePicker";
var KEY_BACKSPACE = 'Backspace';
var KEY_DELETE = 'Delete';
var KEY_F2 = 'F2';
export default /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function (props, ref) {
  var refInput = useRef(null);
  useEffect(function () {
    var _editFocusCell$column, _props$colDef, _editingCells$, _props$colDef2;
    // get ref from React component
    var eInput = refInput === null || refInput === void 0 ? void 0 : refInput.current;
    var editingCells = props.api.getEditingCells();
    var focusedCell = props.api.getFocusedCell();
    // @ts-ignore
    var editFocusCell = editingCells.find(function (cell) {
      var _cell$column, _focusedCell$column;
      return ((_cell$column = cell.column) === null || _cell$column === void 0 ? void 0 : _cell$column.colId) === (focusedCell === null || focusedCell === void 0 || (_focusedCell$column = focusedCell.column) === null || _focusedCell$column === void 0 ? void 0 : _focusedCell$column.colId);
    });
    if (
    // @ts-ignore
    editFocusCell && ((_editFocusCell$column = editFocusCell.column) === null || _editFocusCell$column === void 0 ? void 0 : _editFocusCell$column.colId) === ((_props$colDef = props.colDef) === null || _props$colDef === void 0 ? void 0 : _props$colDef.field) ||
    // @ts-ignore
    !editFocusCell && ((_editingCells$ = editingCells[0]) === null || _editingCells$ === void 0 || (_editingCells$ = _editingCells$.column) === null || _editingCells$ === void 0 ? void 0 : _editingCells$.colId) === ((_props$colDef2 = props.colDef) === null || _props$colDef2 === void 0 ? void 0 : _props$colDef2.field)) {
      eInput === null || eInput === void 0 || eInput.setFocus(true);
      eInput === null || eInput === void 0 || eInput.setOpen(true);
    }

    // if (highlightAllOnFocus) {
    //   eInput.select()

    //   setHighlightAllOnFocus(false)
    // } else {
    //   // when we started editing, we want the caret at the end, not the start.
    //   // this comes into play in two scenarios:
    //   //   a) when user hits F2
    //   //   b) when user hits a printable character
    //   const length = eInput.value ? eInput.value.length : 0
    //   if (length > 0) {
    //     eInput.setSelectionRange(length, length)
    //   }
    // }
  }, []);

  //@ts-ignore
  var _props$formatter = props.formatter,
    formatter = _props$formatter === void 0 ? 'YYYY-MM-DD HH:mm' : _props$formatter;
  var createInitialState = function createInitialState() {
    var startValue;
    var highlightAllOnFocus = true;
    if (props.eventKey === KEY_BACKSPACE || props.eventKey === KEY_DELETE) {
      // if backspace or delete pressed, we clear the cell
      startValue = '';
    } else if (
    // @ts-ignore
    props.charPress) {
      // if a letter was pressed, we start with the letter
      // @ts-ignore
      startValue = props.charPress;
      highlightAllOnFocus = false;
    } else {
      // otherwise we start with the current value
      startValue = props.value;
      if (props.eventKey === KEY_F2) {
        highlightAllOnFocus = false;
      }
    }
    return {
      value: startValue && startValue != 'Invalid Date' ? dayjs(startValue) : dayjs(),
      highlightAllOnFocus: highlightAllOnFocus
    };
  };
  var initialState = createInitialState();
  var _useState = useState(initialState.value),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];

  /* Component Editor Lifecycle methods */
  useImperativeHandle(ref, function () {
    return {
      // the final value to send to the grid, on completion of editing
      getValue: function getValue() {
        return value ? dayjs(value).format(formatter) : '';
      } // Gets called once before editing starts, to give editor a chance to
      // cancel the editing before it even starts.
      // isCancelBeforeStart() {
      //   return cancelBeforeStart
      // },
      // Gets called once when editing is finished (eg if Enter is pressed).
      // If you return true, then the result of the edit will be ignored.
      // isCancelAfterEnd() {
      //   // will reject the number if it greater than 1,000,000
      //   // not very practical, but demonstrates the method.
      //   return value > 100
      // },
    };
  });
  return /*#__PURE__*/React.createElement(XDatePicker, {
    style: {
      width: '100%'
    },
    ref: refInput,
    formatter: formatter,
    value: value,
    onChange: function onChange(e) {
      return setValue(e);
    }
  });
}));