import _Select from "antd/es/select";
import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["onChange"];
/*
 * @Author: chenzenghua
 * @Date: 2023-05-23 19:48:22
 * @LastEditTime: 2023-12-15 14:30:37
 * @LastEditors: chenzenghua
 * @Description:
 */
import React, { forwardRef, memo, useEffect, useImperativeHandle, useRef, useState } from 'react';
import "./styles.less";
var KEY_BACKSPACE = 'Backspace';
var KEY_DELETE = 'Delete';
var KEY_F2 = 'F2';
export default /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function (props, ref) {
  //@ts-ignore
  var _props$antdSelectProp = props.antdSelectProps,
    _onChange = _props$antdSelectProp.onChange,
    antdSelectProps = _objectWithoutProperties(_props$antdSelectProp, _excluded);
  //@ts-ignore
  var _props$antdSelectProp2 = props.antdSelectProps.options,
    options = _props$antdSelectProp2 === void 0 ? [] : _props$antdSelectProp2;
  //@ts-ignore
  if (typeof props.getOptions === 'function') {
    //@ts-ignore
    options = props.getOptions(props.data) || [];
  }
  var createInitialState = function createInitialState() {
    var startValue;
    var highlightAllOnFocus = true;
    if (props.eventKey === KEY_BACKSPACE || props.eventKey === KEY_DELETE) {
      // if backspace or delete pressed, we clear the cell
      startValue = '';
      // @ts-ignore
    } else if (props.charPress) {
      // if a letter was pressed, we start with the letter
      // @ts-ignore
      startValue = props.charPress;
      highlightAllOnFocus = false;
    } else {
      // otherwise we start with the current value
      startValue = props.value;
      if (props.eventKey === KEY_F2) {
        highlightAllOnFocus = false;
      }
    }
    return {
      value: startValue,
      highlightAllOnFocus: highlightAllOnFocus
    };
  };
  var initialState = createInitialState();
  var _useState = useState(initialState.value),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = useState(initialState.highlightAllOnFocus),
    _useState4 = _slicedToArray(_useState3, 2),
    highlightAllOnFocus = _useState4[0],
    setHighlightAllOnFocus = _useState4[1];
  var refInput = useRef(null);

  // focus on the input
  useEffect(function () {
    var _editFocusCell$column, _props$colDef, _editingCells$, _props$colDef2;
    // get ref from React component
    var eInput = refInput.current;
    var editingCells = props.api.getEditingCells();
    var focusedCell = props.api.getFocusedCell();
    //@ts-ignore
    var editFocusCell = editingCells.find(function (cell) {
      var _cell$column, _focusedCell$column;
      return ((_cell$column = cell.column) === null || _cell$column === void 0 ? void 0 : _cell$column.colId) === (focusedCell === null || focusedCell === void 0 || (_focusedCell$column = focusedCell.column) === null || _focusedCell$column === void 0 ? void 0 : _focusedCell$column.colId);
    });

    // @ts-ignore
    if (
    //@ts-ignore
    editFocusCell && ((_editFocusCell$column = editFocusCell.column) === null || _editFocusCell$column === void 0 ? void 0 : _editFocusCell$column.colId) === ((_props$colDef = props.colDef) === null || _props$colDef === void 0 ? void 0 : _props$colDef.field) ||
    //@ts-ignore
    !editFocusCell && ((_editingCells$ = editingCells[0]) === null || _editingCells$ === void 0 || (_editingCells$ = _editingCells$.column) === null || _editingCells$ === void 0 ? void 0 : _editingCells$.colId) === ((_props$colDef2 = props.colDef) === null || _props$colDef2 === void 0 ? void 0 : _props$colDef2.field)) {
      eInput === null || eInput === void 0 || eInput.focus();
    }

    // eInput.focus()
    if (highlightAllOnFocus) {
      // eInput.select()
      setHighlightAllOnFocus(false);
    } else {
      // when we started editing, we want the caret at the end, not the start.
      // this comes into play in two scenarios:
      //   a) when user hits F2
      //   b) when user hits a printable character
      // const length = eInput?.value ? eInput?.value?.length : 0
      // if (length > 0) {
      //   eInput.setSelectionRange(length, length)
      // }
    }
  }, []);

  /* Component Editor Lifecycle methods */
  useImperativeHandle(ref, function () {
    return {
      // the final value to send to the grid, on completion of editing
      getValue: function getValue() {
        return value;
      } // Gets called once before editing starts, to give editor a chance to
      // cancel the editing before it even starts.
      // isCancelBeforeStart() {
      //   return cancelBeforeStart
      // },
      // Gets called once when editing is finished (eg if Enter is pressed).
      // If you return true, then the result of the edit will be ignored.
      // isCancelAfterEnd() {
      //   // will reject the number if it greater than 1,000,000
      //   // not very practical, but demonstrates the method.
      //   return value > 100
      // },
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-select-edit"
  }, /*#__PURE__*/React.createElement(_Select, _extends({
    ref: refInput,
    onChange: function onChange(e) {
      setValue(e);
      _onChange === null || _onChange === void 0 || _onChange(e);
    },
    value: value,
    size: "small",
    style: {
      width: '100%'
    },
    showSearch: true,
    onInputKeyDown: function onInputKeyDown(_ref) {
      var keyCode = _ref.keyCode;
      if (keyCode === 13) {
        console.log(12);
      }
    }
  }, antdSelectProps, {
    options: options
  })));
}));