import _Switch from "antd/es/switch";
import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { forwardRef, memo, useEffect, useImperativeHandle, useRef, useState } from 'react';
import "./styles.less";
var KEY_BACKSPACE = 'Backspace';
var KEY_DELETE = 'Delete';
var KEY_F2 = 'F2';
export default /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function (props, ref) {
  //@ts-ignore
  var antdSwitchProps = props.antdSwitchProps;
  var createInitialState = function createInitialState() {
    var startValue;
    var highlightAllOnFocus = true;
    if (props.eventKey === KEY_BACKSPACE || props.eventKey === KEY_DELETE) {
      // if backspace or delete pressed, we clear the cell
      startValue = '';
      //@ts-ignore
    } else if (props.charPress) {
      // if a letter was pressed, we start with the letter
      //@ts-ignore
      startValue = props.charPress;
      highlightAllOnFocus = false;
    } else {
      // otherwise we start with the current value
      startValue = props.value;
      if (props.eventKey === KEY_F2) {
        highlightAllOnFocus = false;
      }
    }
    return {
      value: startValue,
      highlightAllOnFocus: highlightAllOnFocus
    };
  };
  var initialState = createInitialState();
  var _useState = useState(initialState.value),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = useState(initialState.highlightAllOnFocus),
    _useState4 = _slicedToArray(_useState3, 2),
    highlightAllOnFocus = _useState4[0],
    setHighlightAllOnFocus = _useState4[1];
  var refInput = useRef(null);

  // focus on the input
  useEffect(function () {
    // get ref from React component
    var eInput = refInput.current;
    // eInput.focus()
    if (highlightAllOnFocus) {
      // eInput.select()

      setHighlightAllOnFocus(false);
    } else {}
  }, []);

  /* Component Editor Lifecycle methods */
  useImperativeHandle(ref, function () {
    return {
      // the final value to send to the grid, on completion of editing
      getValue: function getValue() {
        return value;
      } // Gets called once before editing starts, to give editor a chance to
      // cancel the editing before it even starts.
      // isCancelBeforeStart() {
      //   return cancelBeforeStart
      // },
      // Gets called once when editing is finished (eg if Enter is pressed).
      // If you return true, then the result of the edit will be ignored.
      // isCancelAfterEnd() {
      //   // will reject the number if it greater than 1,000,000
      //   // not very practical, but demonstrates the method.
      //   return value > 100
      // },
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-switch-edit"
  }, /*#__PURE__*/React.createElement(_Switch, _extends({
    checked: value,
    onChange: function onChange(e) {
      setValue(e);
    }
  }, antdSwitchProps)));
}));