import _TreeSelect from "antd/es/tree-select";
import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["onChange"];
/*
 * @Author: chenzenghua
 * @Date: 2023-05-23 19:48:22
 * @LastEditTime: 2023-12-15 14:31:01
 * @LastEditors: chenzenghua
 * @Description:
 */
import React, { forwardRef, memo, useEffect, useImperativeHandle, useRef, useState } from 'react';
import "../SelectEditComponent/styles.less";
var KEY_BACKSPACE = 'Backspace';
var KEY_DELETE = 'Delete';
var KEY_F2 = 'F2';
export default /*#__PURE__*/memo( /*#__PURE__*/forwardRef(function (props, ref) {
  //@ts-ignore
  var _props$antdTreeSelect = props.antdTreeSelectProps,
    _onChange = _props$antdTreeSelect.onChange,
    antdTreeSelectProps = _objectWithoutProperties(_props$antdTreeSelect, _excluded);
  var createInitialState = function createInitialState() {
    var startValue;
    var highlightAllOnFocus = true;
    if (props.eventKey === KEY_BACKSPACE || props.eventKey === KEY_DELETE) {
      // if backspace or delete pressed, we clear the cell
      startValue = '';
      //@ts-ignore
    } else if (props.charPress) {
      //@ts-ignore
      // if a letter was pressed, we start with the letter
      startValue = props.charPress;
      highlightAllOnFocus = false;
    } else {
      // otherwise we start with the current value
      startValue = props.value;
      if (props.eventKey === KEY_F2) {
        highlightAllOnFocus = false;
      }
    }
    return {
      value: startValue,
      highlightAllOnFocus: highlightAllOnFocus
    };
  };
  var initialState = createInitialState();
  var _useState = useState(initialState.value),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = useState(initialState.highlightAllOnFocus),
    _useState4 = _slicedToArray(_useState3, 2),
    highlightAllOnFocus = _useState4[0],
    setHighlightAllOnFocus = _useState4[1];
  var refInput = useRef(null);

  // focus on the input
  useEffect(function () {
    // get ref from React component
    // const eInput = refInput.current!
    // let editingCells = props.api.getEditingCells()
    // let focusedCell = props.api.getFocusedCell()
    // //@ts-ignore
    // let editFocusCell = editingCells.find((cell) => cell.column?.colId === focusedCell?.column?.colId)

    // // @ts-ignore
    // if (
    //   //@ts-ignore
    //   (editFocusCell && editFocusCell.column?.colId === props.colDef?.field) ||
    //   //@ts-ignore
    //   (!editFocusCell && editingCells[0]?.column?.colId === props.colDef?.field)
    // ) {
    //   eInput?.focus()
    // }

    // eInput.focus()
    if (highlightAllOnFocus) {
      // eInput.select()
      setHighlightAllOnFocus(false);
    } else {
      // when we started editing, we want the caret at the end, not the start.
      // this comes into play in two scenarios:
      //   a) when user hits F2
      //   b) when user hits a printable character
      // const length = eInput?.value ? eInput?.value?.length : 0
      // if (length > 0) {
      //   eInput.setSelectionRange(length, length)
      // }
    }
  }, []);

  /* Component Editor Lifecycle methods */
  useImperativeHandle(ref, function () {
    return {
      // the final value to send to the grid, on completion of editing
      getValue: function getValue() {
        return value;
      } // Gets called once before editing starts, to give editor a chance to
      // cancel the editing before it even starts.
      // isCancelBeforeStart() {
      //   return cancelBeforeStart
      // },
      // Gets called once when editing is finished (eg if Enter is pressed).
      // If you return true, then the result of the edit will be ignored.
      // isCancelAfterEnd() {
      //   // will reject the number if it greater than 1,000,000
      //   // not very practical, but demonstrates the method.
      //   return value > 100
      // },
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-select-edit"
  }, /*#__PURE__*/React.createElement(_TreeSelect, _extends({
    ref: refInput,
    onChange: function onChange(e) {
      setValue(e);
      _onChange === null || _onChange === void 0 || _onChange(e);
    },
    value: value,
    size: "small",
    style: {
      width: '100%'
    },
    showSearch: true
  }, antdTreeSelectProps)));
}));