import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
/*
 * @Author: chenzenghua
 * @Date: 2022-11-25 14:39:04
 * @LastEditTime: 2023-08-11 09:45:54
 * @LastEditors: chenzenghua
 * @Description: 
 */

/**
 * 跳转到指定行索引
 * @param gridApi
 * @param index
 */
var turnToIndex = function turnToIndex(gridApi, index) {
  gridApi.ensureIndexVisible(index, 'middle');
  // 闪烁一下
  var rowNode = gridApi.getDisplayedRowAtIndex(index);
  if (rowNode) {
    gridApi === null || gridApi === void 0 || gridApi.flashCells({
      rowNodes: [rowNode],
      flashDelay: 2000,
      fadeDelay: 1000
    });
  }
};

/**
 * 跳转到指定ID行
 * @param gridApi
 * @param IDValue ID值
 *  @deprecated 弃用,请使用 TurnToRowByRowID
 */

var turnToRowOfValue = function turnToRowOfValue(gridApi, IDValue) {
  // const rowNode = gridApi.getRowNode(IDValue)
  // const rowNode = gridApi.getDisplayedRowAtIndex(55)
  var rowNode = gridApi.getRowNode(IDValue);
  gridApi.ensureNodeVisible(rowNode, 'middle');
  // 闪烁一下
  if (rowNode) {
    gridApi === null || gridApi === void 0 || gridApi.flashCells({
      rowNodes: [rowNode],
      flashDelay: 2000,
      fadeDelay: 1000
    });
  }
};
var TurnToRowByRowID = function TurnToRowByRowID(gridApi, IDValue) {
  // const rowNode = gridApi.getRowNode(IDValue)
  // const rowNode = gridApi.getDisplayedRowAtIndex(55)
  var rowNode = gridApi.getRowNode(IDValue);
  gridApi.ensureNodeVisible(rowNode, 'middle');
  // 闪烁一下
  if (rowNode) {
    gridApi === null || gridApi === void 0 || gridApi.flashCells({
      rowNodes: [rowNode],
      flashDelay: 2000,
      fadeDelay: 1000
    });
  }
};
/**
 * 导出Excel
 * @param gridApi
 * @param options 导出参数 详:https://www.ag-grid.com/react-data-grid/excel-export-api/
 */
var exportToExcel = function exportToExcel(gridApi, options) {
  var op = _objectSpread({
    fileName: '导出.xlsx',
    sheetName: 'Sheet1',
    headerRowHeight: 30,
    author: '杏和软件'
  }, options);
  gridApi === null || gridApi === void 0 || gridApi.exportDataAsExcel(_objectSpread({}, op));
};
var gridTools = {
  turnToIndex: turnToIndex,
  turnToRowOfValue: turnToRowOfValue,
  exportToExcel: exportToExcel
};
export default gridTools;