import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
//@ts-nocheck
import { CloseCircleFilled, CloseCircleOutlined, DoubleLeftOutlined, DoubleRightOutlined, LeftOutlined, RightOutlined, CalendarOutlined } from '@ant-design/icons';
import { useClickAway, useDebounceFn } from 'ahooks';
import cn from 'date-fns/locale/zh-CN';
import IMask from 'imask';
import dayjs from 'dayjs';
import QueueAnim from 'rc-queue-anim';
import React, { useEffect, useMemo, useRef, useState } from 'react';
import DatePicker, { registerLocale } from 'react-datepicker';
import { IMaskInput } from 'react-imask';
import "../XDatePicker/datepicker.less";
import "./styles.less";
import classNames from 'classnames';
var quarterOfYear = require('dayjs/plugin/quarterOfYear');
dayjs.extend(quarterOfYear);
registerLocale('zh-CN', cn);

/**
 * 已支持的内置快捷方式;
 * 如果需要自定义,请传入自定义函数返回 需返回{ name: string; dateRange: dayjs.Dayjs[] }
 */

export default function Index(props) {
  var _props$minDate, _props$maxDate, _props$maxDate2;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    focused = _useState4[0],
    setFocused = _useState4[1];

  // 不传入时间时,取当前
  //@ts-ignore
  var _ref = props.value && [props.value[0] ? props.value[0].toDate() : undefined, props.value[1] ? props.value[1].toDate() : undefined] || [],
    _ref2 = _slicedToArray(_ref, 2),
    startDate = _ref2[0],
    endDate = _ref2[1];
  var _useState5 = useState(new Date().getFullYear()),
    _useState6 = _slicedToArray(_useState5, 2),
    currYear = _useState6[0],
    setCurrYear = _useState6[1];
  // // 防止重复提交
  var _useDebounceFn = useDebounceFn(function (dataRange) {
      var _props$onChange;
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, dataRange);
    }, {
      wait: 50
    }),
    run = _useDebounceFn.run;
  var months = ['01月', '02月', '03月', '04月', '05月', '06月', '07月', '08月', '09月', '10月', '11月', '12月'];
  var defaultShortcutsLevel1 = ['今天', '昨天', '本周', '上一周', '本月', '上一月'];
  var defaultShortcutsLevel2 = ['本季度', '近三月', '一季度', '二季度', '三季度', '四季度'];
  var defaultShortcutsLevel3 = ['今年', '上半年', '下半年', '上一年', '近一年', '近三年'];
  var ref = useRef(undefined);
  var years = useMemo(function () {
    var i = -(props.yearSelectorSubCount || 2);
    var arr = [];
    var thisYear = dayjs().year();
    while (i <= (props.yearSelectorPreCount || 10)) {
      arr.push(thisYear - i);
      i += 1;
    }
    return arr;
  }, [props.yearSelectorPreCount, props.yearSelectorSubCount]);
  var _props$showShortCut = props.showShortCut,
    showShortCut = _props$showShortCut === void 0 ? true : _props$showShortCut,
    _props$showTime = props.showTime,
    showTime = _props$showTime === void 0 ? false : _props$showTime,
    shortcutList = props.shortcutList;
  var dateFormat = props.showTime ? 'YYYY-MM-DD HH:mm' : 'YYYY-MM-DD';
  // 焦点丢失自动关闭
  useClickAway(function () {
    var _props$onClose;
    setVisible(false);
    (_props$onClose = props.onClose) === null || _props$onClose === void 0 || _props$onClose.call(props);
  }, ref);
  useEffect(function () {
    setVisible(props.visible || false);
  }, [props.visible]);
  useEffect(function () {
    var _props$onOpenChange;
    (_props$onOpenChange = props.onOpenChange) === null || _props$onOpenChange === void 0 || _props$onOpenChange.call(props, visible);
  }, [visible]);
  var triggerChange = function triggerChange(dataRange) {
    run(dataRange);
  };
  var handleShortcut = function handleShortcut(type, goStart, goEnd) {
    var _props$onClose3;
    if (type === 'CUSTOM') {
      var _props$onClose2;
      if (!goStart || !goEnd) {
        console.log('未返回日期范围');
        return;
      }
      if (!props.visibleAfterShortCut) {
        setVisible(false);
      }
      (_props$onClose2 = props.onClose) === null || _props$onClose2 === void 0 || _props$onClose2.call(props);
      run([goStart, goEnd]);
      return;
    }
    var start = dayjs();
    var end = dayjs();
    switch (type) {
      case '今天':
        start = dayjs().startOf('d');
        end = dayjs().endOf('d');
        break;
      case '昨天':
        start = dayjs().add(-1, 'd').startOf('d');
        end = dayjs().add(-1, 'd').endOf('d');
        break;
      case '本周':
        start = dayjs().startOf('week');
        end = dayjs().endOf('week');
        break;
      case '近三天':
        start = dayjs().add(-3, 'd').startOf('d');
        end = dayjs().endOf('d');
        break;
      case '近七天':
        start = dayjs().add(-7, 'd').startOf('d');
        end = dayjs().endOf('d');
        break;
      case '上一周':
        start = dayjs().add(-1, 'week').startOf('week');
        end = dayjs().add(-1, 'week').endOf('week');
        break;
      case '近一周':
        start = dayjs().add(-1, 'week');
        end = dayjs();
        break;
      case '本月':
        start = dayjs().startOf('month');
        end = dayjs().endOf('month');
        break;
      case '上一月':
        start = dayjs().add(-1, 'month').startOf('month');
        end = dayjs().add(-1, 'month').endOf('month');
        break;
      case '近一月':
        start = dayjs().add(-1, 'month');
        end = dayjs();
        break;
      case '近三月':
        start = dayjs().add(-3, 'month');
        end = dayjs();
        break;
      case '本季度':
        //@ts-ignore
        start = dayjs().startOf('quarter');
        //@ts-ignore
        end = dayjs().endOf('quarter');
        break;
      case '上季度':
        //@ts-ignore
        start = dayjs().add(-1, 'quarter').startOf('quarter');
        //@ts-ignore
        end = dayjs().add(-1, 'quarter').endOf('quarter');
        break;
      case '一季度':
        //@ts-ignore
        start = dayjs(dayjs("".concat(currYear, "-02-01"))).startOf('quarter');
        //@ts-ignore
        end = dayjs(dayjs("".concat(currYear, "-02-01"))).endOf('quarter');
        break;
      case '二季度':
        //@ts-ignore
        start = dayjs(dayjs("".concat(currYear, "-05-01"))).startOf('quarter');
        //@ts-ignore
        end = dayjs(dayjs("".concat(currYear, "-05-01"))).endOf('quarter');
        break;
      case '三季度':
        //@ts-ignore
        start = dayjs(dayjs("".concat(currYear, "-08-01"))).startOf('quarter');
        //@ts-ignore
        end = dayjs(dayjs("".concat(currYear, "-08-01"))).endOf('quarter');
        break;
      case '四季度':
        //@ts-ignore
        start = dayjs(dayjs("".concat(currYear, "-11-01"))).startOf('quarter');
        //@ts-ignore
        end = dayjs(dayjs("".concat(currYear, "-11-01"))).endOf('quarter');
        break;
      case '今年':
        start = dayjs().startOf('year');
        end = dayjs().endOf('year');
        break;
      case '上半年':
        start = dayjs().startOf('year');
        end = dayjs().endOf('year').add(-6, 'month');
        break;
      case '下半年':
        start = dayjs().endOf('year').add(-6, 'month');
        end = dayjs().endOf('year');
        break;
      case '上一年':
        start = dayjs().add(-1, 'year').startOf('year');
        end = dayjs().add(-1, 'year').endOf('year');
        break;
      case '近一年':
        start = dayjs().add(-1, 'year').startOf('d');
        end = dayjs().endOf('d');
        break;
      case '近两年':
        start = dayjs().add(-2, 'year').startOf('d');
        end = dayjs().endOf('d');
        break;
      case '近三年':
        start = dayjs().add(-3, 'year').startOf('d');
        end = dayjs().endOf('d');
        break;
      default:
        console.log("".concat(type, "\u672A\u63D0\u4F9B\u5B9E\u73B0"));
        return;
    }
    // 选完后关闭
    setVisible(false);
    (_props$onClose3 = props.onClose) === null || _props$onClose3 === void 0 || _props$onClose3.call(props);
    run([start, end]);
  };
  var memoShortcut = useMemo(function () {
    if (shortcutList) {
      return /*#__PURE__*/React.createElement("div", {
        className: "shortcutPanel"
      }, /*#__PURE__*/React.createElement("div", {
        className: "shortcut shortcutCustom"
      }, shortcutList.map(function (item) {
        if (typeof item === 'function') {
          var _item = item(),
            _item$name = _item.name,
            name = _item$name === void 0 ? '-' : _item$name,
            dateRange = _item.dateRange;
          return /*#__PURE__*/React.createElement("button", {
            key: name,
            onClick: function onClick() {
              return handleShortcut('CUSTOM', dateRange[0], dateRange[1]);
            }
          }, name);
        }
        return /*#__PURE__*/React.createElement("button", {
          key: item,
          onClick: function onClick() {
            return handleShortcut(item);
          }
        }, item);
      })));
    }
    return /*#__PURE__*/React.createElement("div", {
      className: "shortcutPanel"
    }, /*#__PURE__*/React.createElement("div", {
      className: "shortcut"
    }, defaultShortcutsLevel1.map(function (item, index) {
      return (
        /*#__PURE__*/
        //@ts-ignore
        React.createElement("button", {
          size: "small",
          key: "A_".concat(index, "}"),
          onClick: function onClick() {
            return handleShortcut(item);
          }
        }, /*#__PURE__*/React.createElement("span", null, item.toString()))
      );
    })), /*#__PURE__*/React.createElement("div", {
      className: "shortcut"
    }, defaultShortcutsLevel2.map(function (item, index) {
      return (
        /*#__PURE__*/
        //@ts-ignore
        React.createElement("button", {
          size: "small",
          key: "B_".concat(index, "}"),
          onClick: function onClick() {
            return handleShortcut(item);
          }
        }, /*#__PURE__*/React.createElement("span", null, item.toString()))
      );
    })), /*#__PURE__*/React.createElement("div", {
      className: "shortcut"
    }, defaultShortcutsLevel3.map(function (item, index) {
      return (
        /*#__PURE__*/
        //@ts-ignore
        React.createElement("button", {
          size: "small",
          key: "C_".concat(index, "}"),
          onClick: function onClick() {
            return handleShortcut(item);
          }
        }, /*#__PURE__*/React.createElement("span", null, item.toString()))
      );
    })));
  }, [shortcutList, handleShortcut]);
  return /*#__PURE__*/React.createElement("div", {
    className: "xinherc-dp-range ",
    ref: ref,
    onMouseEnter: props.allowClear ? function () {
      setFocused(true);
    } : undefined,
    onMouseLeave: props.allowClear ? function () {
      setFocused(false);
    } : undefined
  }, props.children || /*#__PURE__*/React.createElement("div", {
    className: classNames('input-panel', visible ? 'input-panel-visible' : null, props.multipleRow ? 'mutiple-row' : null),
    style: {
      display: 'flex',
      flexDirection: props.multipleRow ? 'column' : 'row'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      width: '100%'
    }
  }, props.prefix && /*#__PURE__*/React.createElement("div", {
    className: "xinherc-dp-range-prefix"
  }, props.prefix), /*#__PURE__*/React.createElement(IMaskInput, {
    placeholder: "\u5F00\u59CB\u65F6\u95F4",
    disabled: props.disabled,
    className: "startInput ".concat(showTime ? 'hastime' : ''),
    style: {
      borderRight: props.multipleRow ? '1px #d9d9d9 solid' : 'none',
      flex: '1'
    },
    onClick: function onClick() {
      return setVisible(true);
    },
    mask: Date,
    overwrite: true,
    lazy: false,
    value: startDate ? dayjs(startDate).format(dateFormat) : undefined
    // guide
    ,
    pattern: dateFormat,
    unmask: "typed",
    onAccept: function onAccept(value) {
      if (value && dayjs(value).isValid()) {
        if (dayjs(value).format(dateFormat) !== dayjs(startDate).format(dateFormat)) {
          triggerChange([dayjs(value), dayjs(endDate)]);
        }
      }
    }
    // ...and more mask props in a guide
    ,
    format: function format(date) {
      if (date) {
        return dayjs(date).format(dateFormat);
      }
      return '';
    },
    parse: function parse(str) {
      return dayjs(str, dateFormat);
    },
    blocks: {
      YYYY: {
        mask: IMask.MaskedRange,
        from: 1000,
        to: 2500
      },
      MM: {
        mask: IMask.MaskedRange,
        from: 1,
        to: 12
      },
      DD: {
        mask: IMask.MaskedRange,
        from: 1,
        to: 31
      },
      HH: {
        mask: IMask.MaskedRange,
        from: 0,
        to: 23
      },
      mm: {
        mask: IMask.MaskedRange,
        from: 0,
        to: 59
      },
      ss: {
        mask: IMask.MaskedRange,
        from: 0,
        to: 59
      }
    }
  }), !props.multipleRow && /*#__PURE__*/React.createElement("div", {
    className: " iconsplit ".concat(props.disabled ? 'iconsplit-disabled' : '')
  }, "~")), /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      marginTop: props.multipleRow ? '4px' : '0'
    }
  }, props.prefix2 && /*#__PURE__*/React.createElement("div", {
    className: "xinherc-dp-range-prefix"
  }, props.prefix2), /*#__PURE__*/React.createElement(IMaskInput, {
    placeholder: "\u7ED3\u675F\u65F6\u95F4",
    disabled: props.disabled == true,
    className: "endInput ".concat(showTime ? 'hastime' : ''),
    style: {
      borderLeft: props.multipleRow ? '1px #d9d9d9 solid' : 'none',
      flex: '1'
    },
    onClick: function onClick() {
      return setVisible(true);
    },
    mask: Date,
    overwrite: true,
    lazy: false,
    value: endDate ? dayjs(endDate).format(dateFormat) : undefined,
    onChange: function onChange() {}
    // guide
    ,
    pattern: dateFormat,
    unmask: false,
    onAccept: function onAccept(value) {
      //@ts-ignore
      if (value && value.indexOf('_') < 0 && dayjs(value).isValid()) {
        if (dayjs(value).format(dateFormat) !== dayjs(endDate).format(dateFormat)) {
          triggerChange([dayjs(startDate), dayjs(value)]);
        }
      }
    }
    // ...and more mask props in a guide
    ,
    format: function format(date) {
      return dayjs(date).format(dateFormat);
    },
    parse: function parse(str) {
      return dayjs(str, dateFormat);
    },
    blocks: {
      YYYY: {
        mask: IMask.MaskedRange,
        from: 1000,
        to: 2500
      },
      MM: {
        mask: IMask.MaskedRange,
        from: 1,
        to: 12
      },
      DD: {
        mask: IMask.MaskedRange,
        from: 1,
        to: 31
      },
      HH: {
        mask: IMask.MaskedRange,
        from: 0,
        to: 23
      },
      mm: {
        mask: IMask.MaskedRange,
        from: 0,
        to: 59
      },
      ss: {
        mask: IMask.MaskedRange,
        from: 0,
        to: 59
      }
    }
  })), focused && !props.multipleRow && /*#__PURE__*/React.createElement("span", {
    className: "close-icon"
  }, /*#__PURE__*/React.createElement(CloseCircleFilled, {
    style: {
      cursor: 'pointer'
    },
    onClick: function onClick() {
      triggerChange([]);
    }
  })), !focused && !props.multipleRow && /*#__PURE__*/React.createElement("span", {
    className: "icon-calendar"
  }, /*#__PURE__*/React.createElement(CalendarOutlined, {
    style: {
      cursor: 'pointer'
    },
    onClick: function onClick() {
      triggerChange([]);
    }
  }))), visible && /*#__PURE__*/React.createElement(QueueAnim, {
    type: "top",
    style: {
      zIndex: 9999
    }
  }, /*#__PURE__*/React.createElement("div", {
    key: "picker-panel",
    className: "picker-panel ".concat(props.smallSize || props.smallsize ? 'size-small' : ''),
    style: {
      top: props.top || 36,
      // 向右宽度不够时贴右
      left: props.left
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "data-select "
  }, /*#__PURE__*/React.createElement("div", {
    className: "btn-close",
    onClick: function onClick() {
      return setVisible(false);
    }
  }, /*#__PURE__*/React.createElement(CloseCircleOutlined, {
    style: {
      fontSize: '20px'
    }
  })), /*#__PURE__*/React.createElement(DatePicker, {
    renderCustomHeader: function renderCustomHeader(_ref3) {
      var date = _ref3.date,
        changeYear = _ref3.changeYear,
        changeMonth = _ref3.changeMonth,
        decreaseMonth = _ref3.decreaseMonth,
        decreaseYear = _ref3.decreaseYear,
        increaseYear = _ref3.increaseYear,
        increaseMonth = _ref3.increaseMonth,
        prevMonthButtonDisabled = _ref3.prevMonthButtonDisabled,
        prevYearButtonDisabled = _ref3.prevYearButtonDisabled,
        nextYearButtonDisabled = _ref3.nextYearButtonDisabled,
        nextMonthButtonDisabled = _ref3.nextMonthButtonDisabled;
      return /*#__PURE__*/React.createElement("div", {
        className: "dp-head"
      }, /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: decreaseYear,
        disabled: prevYearButtonDisabled,
        title: "\u4E0A\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleLeftOutlined, null)), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: decreaseMonth,
        disabled: prevMonthButtonDisabled,
        title: "\u4E0A\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement("select", {
        value: dayjs(date).year(),
        onChange: function onChange(_ref4) {
          var value = _ref4.target.value;
          return changeYear(value);
        }
      }, years.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("select", {
        value: months[dayjs(date).month()],
        onChange: function onChange(_ref5) {
          var value = _ref5.target.value;
          return changeMonth(months.indexOf(value));
        }
      }, months.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: increaseMonth,
        disabled: nextMonthButtonDisabled,
        title: "\u4E0B\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(RightOutlined, null)), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: increaseYear,
        disabled: nextYearButtonDisabled,
        title: "\u4E0B\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleRightOutlined, null)));
    },
    onYearChange: function onYearChange(e) {
      setCurrYear(e.getFullYear());
    },
    closeOnScroll: true,
    autoFocus: false,
    disabledKeyboardNavigation: true,
    selected: startDate,
    onChange: function onChange(date) {
      // @ts-ignore
      triggerChange([dayjs(date), dayjs(endDate)]);
    },
    inline: true,
    dateFormat: dateFormat.replace('YYYY', 'yyyy').replace('DD', 'dd'),
    timeFormat: "HH:mm",
    showTimeSelect: props.showTime,
    timeCaption: "\u65F6\u95F4\u70B9",
    timeIntervals: props.timeIntervals || 30,
    locale: "zh-CN",
    minDate: (_props$minDate = props.minDate) === null || _props$minDate === void 0 ? void 0 : _props$minDate.toDate(),
    maxDate: (_props$maxDate = props.maxDate) === null || _props$maxDate === void 0 ? void 0 : _props$maxDate.toDate()
  }), /*#__PURE__*/React.createElement("div", {
    className: "end-panel",
    style: {
      borderLeft: '1px #dbd9d9 solid'
    }
  }, /*#__PURE__*/React.createElement(DatePicker, {
    renderCustomHeader: function renderCustomHeader(_ref6) {
      var date = _ref6.date,
        changeYear = _ref6.changeYear,
        changeMonth = _ref6.changeMonth,
        decreaseMonth = _ref6.decreaseMonth,
        decreaseYear = _ref6.decreaseYear,
        increaseYear = _ref6.increaseYear,
        increaseMonth = _ref6.increaseMonth,
        prevMonthButtonDisabled = _ref6.prevMonthButtonDisabled,
        prevYearButtonDisabled = _ref6.prevYearButtonDisabled,
        nextYearButtonDisabled = _ref6.nextYearButtonDisabled,
        nextMonthButtonDisabled = _ref6.nextMonthButtonDisabled;
      return /*#__PURE__*/React.createElement("div", {
        className: "dp-head"
      }, /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: decreaseYear,
        disabled: prevYearButtonDisabled,
        title: "\u4E0A\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleLeftOutlined, null)), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: decreaseMonth,
        disabled: prevMonthButtonDisabled,
        title: "\u4E0A\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement("select", {
        value: dayjs(date).year(),
        onChange: function onChange(_ref7) {
          var value = _ref7.target.value;
          return changeYear(value);
        }
      }, years.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("select", {
        value: months[dayjs(date).month()],
        onChange: function onChange(_ref8) {
          var value = _ref8.target.value;
          return changeMonth(months.indexOf(value));
        }
      }, months.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: increaseMonth,
        disabled: nextMonthButtonDisabled,
        title: "\u4E0B\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(RightOutlined, null)), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: increaseYear,
        disabled: nextYearButtonDisabled,
        title: "\u4E0B\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleRightOutlined, null)));
    },
    closeOnScroll: true,
    autoFocus: false,
    disabledKeyboardNavigation: true,
    selected: endDate
    // @ts-ignore
    ,
    onChange: function onChange(date) {
      return triggerChange([dayjs(startDate), dayjs(date)]);
    },
    startDate: startDate,
    minDate: startDate,
    maxDate: (_props$maxDate2 = props.maxDate) === null || _props$maxDate2 === void 0 ? void 0 : _props$maxDate2.toDate(),
    inline: true,
    timeFormat: "HH:mm",
    showTimeSelect: props.showTime,
    timeCaption: "\u65F6\u95F4\u70B9",
    timeIntervals: props.timeIntervals || 30,
    locale: "zh-CN"
  }))), showShortCut && memoShortcut)));
}