import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
//@ts-nocheck
import { CalendarOutlined, CloseCircleFilled, DoubleLeftOutlined, DoubleRightOutlined, LeftOutlined, RightOutlined } from '@ant-design/icons';
import cn from 'date-fns/locale/zh-CN';
import IMask from 'imask';
import dayjs from 'dayjs';
import React, { forwardRef, useEffect, useMemo, useRef, useState } from 'react';
import DatePicker, { registerLocale } from 'react-datepicker';
import { IMaskInput } from 'react-imask';
import "./datepicker.less";
import "./style.less";
import { monthsDict } from "./typing";
registerLocale('zh-CN', cn);
function XDatePicker(props, ref) {
  var _props$value, _props$style, _props$minDate, _props$maxDate;
  var _useState = useState(((_props$value = props.value) === null || _props$value === void 0 ? void 0 : _props$value.toDate()) || (props.defaultNull ? undefined : new Date())),
    _useState2 = _slicedToArray(_useState, 2),
    startDate = _useState2[0],
    setStartDate = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    focued = _useState4[0],
    setfocued = _useState4[1];
  var dateFormat = props.formatter || 'YYYY-MM-DD HH:mm';
  // 触发change
  var triggerChange = function triggerChange(date) {
    var _props$onChange;
    setStartDate(date === null || date === void 0 ? void 0 : date.toDate());
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, date ? dayjs(date) : date);
  };
  useEffect(function () {
    if (props.value !== null) {
      var _props$value2;
      var s = ((_props$value2 = props.value) === null || _props$value2 === void 0 ? void 0 : _props$value2.toDate()) || (props.defaultNull ? undefined : new Date());
      if (startDate !== s) {
        setStartDate(s);
      }
    }
  }, [props.value]);
  var CustomInput = /*#__PURE__*/forwardRef(function (_ref, ref) {
    var value = _ref.value,
      onClick = _ref.onClick;
    var refmask = useRef(null);
    // useEffect(() => {
    //   if (refmask?.current) {
    //     refmask.current.element.focus()
    //   }
    // }, [refmask])
    // console.log(value)
    return /*#__PURE__*/React.createElement(IMaskInput, {
      disabled: props.disabled == true,
      readOnly: props.readOnly,
      onClick: onClick,
      mask: Date,
      overwrite: true,
      lazy: false,
      onChange: function onChange() {},
      value: value,
      ref: refmask
      // guide
      ,
      pattern: dateFormat,
      unmask: false,
      onAccept:
      // depending on prop above first argument is
      // `value` if `unmask=false`,
      // `unmaskedValue` if `unmask=true`,
      // `typedValue` if `unmask='typed'`

      function onAccept(v) {
        if (props.formatter === 'HH:mm' || props.showTimeSelectOnly === true) {
          var d = dayjs().format('YYYY-MM-DD ' + v + ':00');
          if (v && dayjs(d).isValid()) {
            if (dayjs(d).format(dateFormat) !== dayjs(startDate).format(dateFormat)) {
              triggerChange(dayjs(d));
            }
          }
        } else if (props.formatter === 'MM-DD') {
          var _d = startDate && "".concat(startDate.getFullYear(), "-").concat(v);
          if (v && dayjs(_d).isValid()) {
            if (dayjs(_d).format(dateFormat) !== dayjs(startDate).format(dateFormat)) {
              triggerChange(dayjs(_d));
            }
          }
        } else {
          if (v && dayjs(v).isValid()) {
            if (dayjs(v).format(dateFormat) !== dayjs(startDate).format(dateFormat)) {
              triggerChange(dayjs(v));
            }
          } else {
            if ((v === null || v === void 0 ? void 0 : v.toString().replaceAll(/[^0-9]/g, '')) === '') {
              triggerChange(null);
            }
          }
        }
      }
      // ...and more mask props in a guide
      ,
      format: function format(date) {
        return dayjs(date).format(dateFormat);
      },
      parse: function parse(str) {
        return dayjs(str, dateFormat);
      },
      blocks: {
        YYYY: {
          mask: IMask.MaskedRange,
          from: 1000,
          to: 2500
        },
        MM: {
          mask: IMask.MaskedRange,
          from: 1,
          to: 12
        },
        DD: {
          mask: IMask.MaskedRange,
          from: 1,
          to: 31
        },
        HH: {
          mask: IMask.MaskedRange,
          from: 0,
          to: 23
        },
        mm: {
          mask: IMask.MaskedRange,
          from: 0,
          to: 59
        },
        ss: {
          mask: IMask.MaskedRange,
          from: 0,
          to: 59
        }
      }
    });
  });
  var defaultWidth = function defaultWidth() {
    var width = 110;
    switch (dateFormat) {
      case 'YYYY-MM-DD':
        width = 100;
        break;
      case 'YYYY-MM-DD HH:mm':
        width = 145;
        break;
      case 'YYYY-MM-DD HH:mm:ss':
        width = 162;
        break;
      case 'MM-DD':
      case 'HH:mm':
        width = 72;
        break;
      default:
        break;
    }
    return "".concat(width + (props.fastNav ? 30 : 0), "px");
  };
  var onPre = function onPre() {
    // eslint-disable-next-line no-nested-ternary
    var type = props.fastNav === '天' ? 'd' : props.fastNav === '小时' ? 'h' : 'M';
    var newDate = dayjs(startDate).add(-1, type);
    setStartDate(newDate.toDate());
    triggerChange(newDate);
  };
  var onNext = function onNext() {
    // eslint-disable-next-line no-nested-ternary
    var type = props.fastNav === '天' ? 'd' : props.fastNav === '小时' ? 'h' : 'M';
    var newDate = dayjs(startDate).add(1, type);
    setStartDate(newDate.toDate());
    triggerChange(newDate);
  };
  var years = useMemo(function () {
    var i = -(props.yearSelectorSubCount || 2);
    var arr = [];
    var thisYear = dayjs().year();
    while (i <= (props.yearSelectorPreCount || 10)) {
      arr.push(thisYear - i);
      i += 1;
    }
    return arr;
  }, [props.yearSelectorPreCount, props.yearSelectorSubCount]);
  return /*#__PURE__*/React.createElement("div", {
    className: "xinherc-dp ".concat(props.smallSizePop ? 'xinherc-dp-small' : '', " ").concat(props.disabled ? 'xinherc-dp-disabled' : ''),
    style: _objectSpread(_objectSpread({}, props.style), {}, {
      width: ((_props$style = props.style) === null || _props$style === void 0 ? void 0 : _props$style.width) || defaultWidth(),
      flexShrink: 0
    }),
    onMouseEnter: props.allowClear ? function () {
      setfocued(true);
    } : undefined,
    onMouseLeave: props.allowClear ? function () {
      setfocued(false);
    } : undefined
  }, focued && /*#__PURE__*/React.createElement(CloseCircleFilled, {
    className: "dp-icon-close",
    style: {
      right: props.fastNav ? '20px' : '8px',
      cursor: 'pointer'
    },
    onClick: function onClick() {
      var _props$onChange2;
      setStartDate(undefined);
      (_props$onChange2 = props.onChange) === null || _props$onChange2 === void 0 || _props$onChange2.call(props, null);
    }
  }) || /*#__PURE__*/React.createElement(CalendarOutlined, {
    className: "dp-icon",
    style: {
      right: props.fastNav ? '20px' : '8px'
    }
  }), props.fastNav && /*#__PURE__*/React.createElement("div", {
    className: "shortcut",
    title: "\u4E0A\u4E00".concat(props.fastNav),
    onClick: onPre
  }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement(DatePicker, {
    readOnly: props.readOnly,
    ref: ref,
    renderCustomHeader: function renderCustomHeader(_ref2) {
      var date = _ref2.date,
        changeYear = _ref2.changeYear,
        changeMonth = _ref2.changeMonth,
        decreaseMonth = _ref2.decreaseMonth,
        decreaseYear = _ref2.decreaseYear,
        increaseYear = _ref2.increaseYear,
        increaseMonth = _ref2.increaseMonth,
        prevMonthButtonDisabled = _ref2.prevMonthButtonDisabled,
        prevYearButtonDisabled = _ref2.prevYearButtonDisabled,
        nextYearButtonDisabled = _ref2.nextYearButtonDisabled,
        nextMonthButtonDisabled = _ref2.nextMonthButtonDisabled;
      return /*#__PURE__*/React.createElement("div", {
        className: "dp-head"
      }, /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: decreaseYear,
        disabled: prevYearButtonDisabled,
        title: "\u4E0A\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleLeftOutlined, null)), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: decreaseMonth,
        disabled: prevMonthButtonDisabled,
        title: "\u4E0A\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement("select", {
        value: dayjs(date).year(),
        onChange: function onChange(_ref3) {
          var value = _ref3.target.value;
          return changeYear(value);
        }
      }, years.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("select", {
        value: monthsDict[dayjs(date).month()],
        onChange: function onChange(_ref4) {
          var value = _ref4.target.value;
          return changeMonth(monthsDict.indexOf(value));
        }
      }, monthsDict.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: increaseMonth,
        disabled: nextMonthButtonDisabled,
        title: "\u4E0B\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(RightOutlined, null)), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: increaseYear,
        disabled: nextYearButtonDisabled,
        title: "\u4E0B\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleRightOutlined, null)));
    },
    onYearChange: function onYearChange(e) {
      //setcurrYear(e.getFullYear())
    },
    disabled: props.disabled == true,
    todayButton: "\u4ECA\u5929",
    timeFormat: "HH:mm",
    closeOnScroll: true,
    autoFocus: false,
    disabledKeyboardNavigation: true,
    showTimeSelect: props.formatter === 'YYYY-MM-DD' ? false : props.showTimeSelect !== false,
    selected: startDate,
    showTimeSelectOnly: props.formatter === 'HH:mm' || props.showTimeSelectOnly === true,
    onChange: function onChange(e) {
      triggerChange(dayjs(e));
    }
    // date-fns 跟dayjs 定义的格式不一致
    ,
    dateFormat: dateFormat.replace('YYYY', 'yyyy').replace('DD', 'dd'),
    customInput: /*#__PURE__*/React.createElement(CustomInput, {
      ref: ref
    }),
    locale: "zh-CN",
    timeCaption: "\u65F6\u95F4\u70B9",
    timeIntervals: props.timeIntervals || 30,
    fixedHeight: true,
    showPopperArrow: false,
    showWeekNumbers: props.showWeekNumbers,
    weekLabel: "\u5468\u6B21"
    //@ts-ignore
    ,
    popperModifiers: [{
      name: 'offset',
      options: {
        offset: props.popOffset || [0, -8]
      }
    }],
    minDate: (_props$minDate = props.minDate) === null || _props$minDate === void 0 ? void 0 : _props$minDate.toDate(),
    maxDate: (_props$maxDate = props.maxDate) === null || _props$maxDate === void 0 ? void 0 : _props$maxDate.toDate()
  }), props.fastNav && /*#__PURE__*/React.createElement("div", {
    className: "shortcut righticon",
    title: "\u4E0B\u4E00".concat(props.fastNav),
    onClick: onNext
  }, /*#__PURE__*/React.createElement(RightOutlined, null)));
}
export default /*#__PURE__*/forwardRef(XDatePicker);