import type { GetProps } from 'antd';
import { Modal } from 'antd';
import React from 'react';
import { DraggableData, DraggableEvent } from 'react-draggable';
import './styles.less';
import { ResizeCallbackData } from 'react-resizable';
export interface DraggableModalProps extends GetProps<typeof Modal> {
    /**
     * 弹窗宽度
     */
    width?: number | string;
    /**
     * 弹窗高度
     */
    height?: number;
    /**
     * 拖动开始事件
     */
    onStart?: (e: DraggableEvent, data: DraggableData) => void;
    /**
     * 拖动结束事件
     */
    onStop?: (e: DraggableEvent, data: DraggableData) => void;
    /** 初始位置 */
    defaultPosition?: {
        x: number;
        y: number;
    };
    /**
     * 隐藏标题*/
    hiddenTitle?: boolean;
    /**
     * 开启宽高拉伸
     */
    allowResize?: boolean;
    /**
     * resize最小值
     * @default null
     */
    minConstraints?: [number, number];
    /**
     * resize最大值
     * @default [Infinity, Infinity]
     */
    maxConstraints?: [number, number];
    /**
     * resize时锁定长宽比
     * @default false
     */
    lockAspectRatio?: boolean;
    /**
     * 弹窗大小拖拽事件
     */
    onResize?: ((e: React.SyntheticEvent<Element, Event>, data: ResizeCallbackData) => any) | undefined;
    /**
     * 无边框模式
     */
    noFrame?: boolean;
    children?: React.ReactNode;
    /**
     * 标题图标
     */
    titleIcon?: React.ReactNode;
    /**
     * 隐藏默认标题图标
     */
    hideDefaultTitleIcon?: boolean;
    sizeControl?: boolean;
}
declare const _default: React.MemoExoticComponent<(props: DraggableModalProps) => React.JSX.Element>;
export default _default;
