import _ConfigProvider from "antd/es/config-provider";
import _Modal from "antd/es/modal";
import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useCallback, useEffect, useLayoutEffect, useMemo, useRef, useState } from 'react';
import Draggable from 'react-draggable';
import "./styles.less";
import { BorderOutlined, MinusOutlined } from '@ant-design/icons';
import { Resizable } from 'react-resizable';
import { getPaddingAll } from "./util";
import { StyleProvider, legacyLogicalPropertiesTransformer } from '@ant-design/cssinjs';
import { PopTitleIcon } from "../XIcons";
import { omit } from 'lodash';
import { XAntdConfig } from "./..";
var RESIZE_HANDLES = ['se'];
var DraggableModal = function DraggableModal(props) {
  var height = props.height,
    width = props.width,
    open = props.open,
    visible = props.visible,
    onStart = props.onStart,
    onStop = props.onStop,
    defaultPosition = props.defaultPosition,
    hiddenTitle = props.hiddenTitle,
    footer = props.footer,
    className = props.className,
    title = props.title,
    noFrame = props.noFrame,
    allowResize = props.allowResize,
    lockAspectRatio = props.lockAspectRatio,
    minConstraints = props.minConstraints,
    maxConstraints = props.maxConstraints,
    onResize = props.onResize,
    children = props.children;
  var _useState = useState({
      left: 0,
      top: 0,
      bottom: 0,
      right: 0
    }),
    _useState2 = _slicedToArray(_useState, 2),
    bounds = _useState2[0],
    setbounds = _useState2[1];
  var ref = useRef();
  var ref1 = useRef();
  var inResizing = useRef();
  var _useState3 = useState(true),
    _useState4 = _slicedToArray(_useState3, 2),
    disabled = _useState4[0],
    setdisabled = _useState4[1];
  var _useState5 = useState(width || 416),
    _useState6 = _slicedToArray(_useState5, 2),
    _width = _useState6[0],
    setWidth = _useState6[1];
  var _useState7 = useState(height || 0),
    _useState8 = _slicedToArray(_useState7, 2),
    _height = _useState8[0],
    setHeight = _useState8[1];
  var _useState9 = useState(false),
    _useState10 = _slicedToArray(_useState9, 2),
    isDragging = _useState10[0],
    setIsDragging = _useState10[1]; // 是否正在拖动1.用于给内容wrapper加不能选中的效果
  var _useState11 = useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    bigSize = _useState12[0],
    setBigSize = _useState12[1];
  // 可见性兼容
  var _visible = open || visible;
  var _maxConstraints = useMemo(function () {
    return maxConstraints || [Infinity, Infinity];
  }, [maxConstraints]);

  // 允许拖动到边界外
  var _onStart = useCallback(function (event, uiData) {
    var _window, _ref$current;
    var _window$document$docu = (_window = window) === null || _window === void 0 || (_window = _window.document) === null || _window === void 0 ? void 0 : _window.documentElement,
      clientWidth = _window$document$docu.clientWidth,
      clientHeight = _window$document$docu.clientHeight;
    var targetRect = ref === null || ref === void 0 || (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.getBoundingClientRect();
    setIsDragging(true);
    setbounds({
      left: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.left) + (uiData === null || uiData === void 0 ? void 0 : uiData.x) - (targetRect === null || targetRect === void 0 ? void 0 : targetRect.width) + 60,
      right: clientWidth - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.right) - (uiData === null || uiData === void 0 ? void 0 : uiData.x)) + (targetRect === null || targetRect === void 0 ? void 0 : targetRect.width) - 60,
      top: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.top) + (uiData === null || uiData === void 0 ? void 0 : uiData.y),
      bottom: clientHeight - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.bottom) - (uiData === null || uiData === void 0 ? void 0 : uiData.y)) + (targetRect === null || targetRect === void 0 ? void 0 : targetRect.height) - 60
    });
    onStart === null || onStart === void 0 || onStart(event, uiData);
  }, [onStart]);
  var _onStop = useCallback(function (event, uiData) {
    setIsDragging(false);
    onStop === null || onStop === void 0 || onStop(event, uiData);
  }, [onStop]);
  var throttleRef = useRef(false);
  // 大小拉伸
  var _onResize = useCallback(function (event, data) {
    var size = data.size;
    setWidth(size.width);
    setHeight(size.height);
    throttleRef.current = false;
    onResize === null || onResize === void 0 || onResize(event, data);
  }, [onResize]);
  useEffect(function () {
    if (bigSize) {
      setWidth('95vw');
      setHeight('90vh');
    } else {
      setWidth(width || 416);
      setHeight(height || 0);
    }
  }, [bigSize]);

  // 外部宽度变更
  useEffect(function () {
    if (width && width !== _width) {
      setWidth(width);
    }
  }, [width]);

  // 外部高度变更
  useEffect(function () {
    if (height && height !== _height) {
      setHeight(height);
    }
  }, [height]);

  // 进入大小拉伸模式，内容高度和宽度接管初始化
  useLayoutEffect(function () {
    if (!_visible || !allowResize || _height && typeof _width !== 'string') {
      return;
    }
    // 解决取不到元素
    setTimeout(function () {
      var contEle = ref1 === null || ref1 === void 0 ? void 0 : ref1.current;
      if (contEle) {
        var _contEle$getBoundingC = contEle === null || contEle === void 0 ? void 0 : contEle.getBoundingClientRect(),
          _height2 = _contEle$getBoundingC.height,
          _width2 = _contEle$getBoundingC.width;
        if (!_height) {
          setHeight(_height2);
        }
        // 在width为string的时候，计算内容宽度+总padding撑开
        if (typeof _width === 'string') {
          var paddingAll = getPaddingAll(contEle, 'ant-modal-body');
          setWidth(_width2 + paddingAll);
        }
      }
    });
  }, [_visible, allowResize, _height, _width]);
  var onResizeStart = useCallback(function () {
    inResizing.current = true;
  }, []);
  var onResizeStop = useCallback(function () {
    inResizing.current = false;
  }, []);
  var wrapperCss = useMemo(function () {
    return {
      height: _height
    };
  }, [_height]);
  var normalCss = useMemo(function () {
    return {
      height: _height ? _height : undefined
    };
  }, [_height]);
  var resizeCss = useMemo(function () {
    return {
      height: _height ? '100%' : undefined
    };
  }, [_height]);
  var titleEle = useMemo(function () {
    return hiddenTitle || noFrame ? undefined : /*#__PURE__*/React.createElement("div", {
      className: "title-container",
      onMouseEnter: function onMouseEnter() {
        if (disabled) {
          setdisabled(false);
        }
      },
      onMouseLeave: function onMouseLeave() {
        setdisabled(true);
      }
    }, props.hideDefaultTitleIcon !== true && /*#__PURE__*/React.createElement("span", {
      className: "title-icon"
    }, props.titleIcon || /*#__PURE__*/React.createElement(PopTitleIcon, {
      style: {
        fontSize: '16px'
      }
    })), title || '标题', props.sizeControl && /*#__PURE__*/React.createElement("button", {
      type: "button",
      onClick: function onClick() {
        setBigSize(!bigSize);
      },
      className: "ant-modal-close",
      style: {
        right: 42
      }
    }, bigSize ? /*#__PURE__*/React.createElement(MinusOutlined, null) : /*#__PURE__*/React.createElement(BorderOutlined, null)));
  }, [disabled, hiddenTitle, noFrame, bigSize, props.hideDefaultTitleIcon, props.titleIcon, title]);
  var modalRender = useCallback(function (modal) {
    return /*#__PURE__*/React.createElement(Draggable, {
      defaultPosition: defaultPosition || undefined,
      onStop: _onStop,
      disabled: disabled,
      bounds: bounds
      //@ts-ignore
      ,
      onStart: _onStart
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        height: '100%',
        width: '100%'
      },
      ref: ref
    }, modal));
  }, [_onStart, bigSize, defaultPosition, bounds, disabled, _onStop]);
  var transformers = useMemo(function () {
    return [legacyLogicalPropertiesTransformer];
  }, []);
  var otherProps = useMemo(function () {
    return bigSize ? omit(props, ['height', 'style']) : omit(props, ['height']);
  }, [props, bigSize]);
  return /*#__PURE__*/React.createElement(StyleProvider, {
    transformers: transformers,
    hashPriority: "high"
  }, /*#__PURE__*/React.createElement(_ConfigProvider, XAntdConfig, /*#__PURE__*/React.createElement(_Modal, _extends({
    open: _visible,
    modalRender: modalRender
    //@ts-ignore
  }, otherProps, {
    width: _width,
    title: titleEle,
    footer: footer || null,
    className: "xinherc-xdraggablemodal ".concat(noFrame ? 'xdraggablemodal-no-frame' : '', " ").concat(allowResize ? 'f-resize' : '', " ").concat(className)
  }), isDragging ? /*#__PURE__*/React.createElement("div", {
    className: "mask"
  }) : '', allowResize ? /*#__PURE__*/React.createElement("div", {
    style: wrapperCss
  }, /*#__PURE__*/React.createElement(Resizable, {
    lockAspectRatio: !!lockAspectRatio,
    minConstraints: minConstraints,
    maxConstraints: _maxConstraints,
    width: typeof _width === 'string' ? 0 : _width,
    height: _height,
    onResize: _onResize,
    onResizeStart: onResizeStart,
    onResizeStop: onResizeStop,
    axis: "both",
    resizeHandles: RESIZE_HANDLES
  }, /*#__PURE__*/React.createElement("div", {
    style: resizeCss,
    ref: ref1
  }, children))) :
  /*#__PURE__*/
  // 有高度用高度，没有就自适应
  React.createElement("div", {
    style: normalCss
  }, children))));
};
export default /*#__PURE__*/React.memo(DraggableModal);