import _ConfigProvider from "antd/es/config-provider";
import _Flex from "antd/es/flex";
import _Form from "antd/es/form";
import _Upload from "antd/es/upload";
import _Row from "antd/es/row";
import _Col from "antd/es/col";
import _Image from "antd/es/image";
import _Cascader from "antd/es/cascader";
import _TreeSelect from "antd/es/tree-select";
import _TimePicker from "antd/es/time-picker";
import _ColorPicker from "antd/es/color-picker";
import _Slider from "antd/es/slider";
import _Switch from "antd/es/switch";
import _Rate from "antd/es/rate";
import _DatePicker from "antd/es/date-picker";
import _Radio from "antd/es/radio";
import _Select from "antd/es/select";
import _Checkbox from "antd/es/checkbox";
import _InputNumber from "antd/es/input-number";
import _Input from "antd/es/input";
import _extends from "@babel/runtime/helpers/esm/extends";
import _Button from "antd/es/button";
import _Divider from "antd/es/divider";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _regeneratorRuntime from "@babel/runtime/helpers/esm/regeneratorRuntime";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useImperativeHandle, useEffect, useState } from 'react';
import dayjs from 'dayjs';
import 'dayjs/locale/zh-cn';
import { cloneDeep, findLastIndex, isEmpty, isNull, omit, last, get, groupBy, round } from 'lodash';
import { XAntdConfig, XTitle } from "./..";
import { UploadOutlined, PlusOutlined, MinusOutlined } from '@ant-design/icons';
import provincesData2Options from "./Province/provincesUtils";
import "./styles.less";
import advancedFormat from 'dayjs/plugin/advancedFormat';
import customParseFormat from 'dayjs/plugin/customParseFormat';
import localeData from 'dayjs/plugin/localeData';
import weekday from 'dayjs/plugin/weekday';
import weekOfYear from 'dayjs/plugin/weekOfYear';
import weekYear from 'dayjs/plugin/weekYear';
dayjs.extend(customParseFormat);
dayjs.extend(advancedFormat);
dayjs.extend(weekday);
dayjs.extend(localeData);
dayjs.extend(weekOfYear);
dayjs.extend(weekYear);
dayjs.locale('zh-cn');
/**复杂表单 */
function XFormView(props, ref) {
  var _formOption$layout, _formOption$layout2, _formOption$layout3, _formOption$layout4, _formOption$layout5, _formOption$layout6, _formOption$layout7, _formOption$layout8, _formOption$layout9;
  var form = props.form,
    formJson = props.formJson,
    dataSourceEnum = props.dataSourceEnum,
    formData = props.formData,
    readOnly = props.readOnly,
    fileBaseUrl = props.fileBaseUrl,
    extraContent = props.extraContent,
    onUpload = props.onUpload,
    onValuesChange = props.onValuesChange;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    formOption = _useState2[0],
    setFormOption = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    previewImage = _useState4[0],
    setPreviewImage = _useState4[1];
  //为了更新展示的动态数据
  var _useState5 = useState({}),
    _useState6 = _slicedToArray(_useState5, 2),
    formValue = _useState6[0],
    setFormValue = _useState6[1];
  //初始化赋值
  useEffect(function () {
    if (!isEmpty(formData) && formJson) {
      var newFormRows = cloneDeep(formJson === null || formJson === void 0 ? void 0 : formJson.rows);
      var defaultForm = {};
      var groupList = [];
      //获取设置了动态表单的按钮
      newFormRows === null || newFormRows === void 0 || newFormRows.forEach(function (row) {
        var _row$cols;
        (_row$cols = row.cols) === null || _row$cols === void 0 || _row$cols.forEach(function (col) {
          var _col$items;
          (_col$items = col.items) === null || _col$items === void 0 || _col$items.forEach(function (item) {
            var _item$widgetProps, _item$widgetProps2;
            if (['Divider', 'XTitle'].includes(item.dataType) && (_item$widgetProps = item.widgetProps) !== null && _item$widgetProps !== void 0 && _item$widgetProps.button && (_item$widgetProps2 = item.widgetProps) !== null && _item$widgetProps2 !== void 0 && _item$widgetProps2.groupKey) {
              var _item$widgetProps3;
              groupList.push((_item$widgetProps3 = item.widgetProps) === null || _item$widgetProps3 === void 0 ? void 0 : _item$widgetProps3.groupKey);
            }
          });
        });
      });
      //按数据生成表单,有动态数据`${groupKey}@${newRow.rowId}@${cloneId}`
      groupList.forEach(function (groupKey) {
        //有复制行
        if (!isEmpty(formData[groupKey])) {
          var cloneRowDataList = formData[groupKey];
          //本身占一行,不计入
          if (cloneRowDataList.length > 1) {
            cloneRowDataList.forEach(function (obj, i) {
              if (i === 0) {
                return;
              }
              var cloneRow = newFormRows === null || newFormRows === void 0 ? void 0 : newFormRows.find(function (row) {
                return row.rowId === groupKey;
              });
              if (isEmpty(cloneRow)) {
                return;
              }
              var newRow = cloneDeep(cloneRow);
              newRow.rowType = 'clone';
              newRow.rowId = "".concat(groupKey, "@").concat(i);
              newRow.cols.map(function (col) {
                col.colId = "".concat(groupKey, "@").concat(col.colId, "@").concat(i);
                col.items.map(function (item) {
                  var itemId = "".concat(groupKey, "@").concat(item.itemId, "@").concat(i);
                  item.itemId = itemId;
                  item.formCode = "".concat(item.formCode, "@").concat(i);
                });
              });
              var index = findLastIndex(newFormRows, function (obj) {
                return obj.rowId.includes(groupKey);
              });
              newFormRows === null || newFormRows === void 0 || newFormRows.splice(index + 1, 0, newRow);
            });
          }
        }
      });
      var getFormData = function getFormData(item, row, dataId) {
        var _row$rowId;
        var dataValue = formData[item.formCode] || get(formData, [(_row$rowId = row.rowId) === null || _row$rowId === void 0 ? void 0 : _row$rowId.split('@')[0], dataId[1] || 0, dataId[0]]);
        if (dataValue) {
          switch (item.dataType) {
            case 'RangePicker':
              var range = dataValue === null || dataValue === void 0 ? void 0 : dataValue.split(',');
              try {
                defaultForm[item.formCode] = [dayjs(range[0]), dayjs(range[1])];
              } catch (error) {
                console.log(error);
              }
              break;
            case 'DatePicker':
              try {
                defaultForm[item.formCode] = dayjs(dataValue);
              } catch (error) {
                console.log(error);
              }
              break;
            case 'TimePicker':
              try {
                defaultForm[item.formCode] = dayjs(dataValue, 'HH:mm:ss');
              } catch (error) {
                console.log(error);
              }
              break;
            case 'TimeRangePicker':
              var timeRange = dataValue === null || dataValue === void 0 ? void 0 : dataValue.split(',');
              try {
                defaultForm[item.itemId] = [dayjs(timeRange[0], 'HH:mm:ss'), dayjs(timeRange[1], 'HH:mm:ss')];
              } catch (error) {
                console.log(error);
              }
              break;
            default:
              defaultForm[item.formCode] = dataValue;
              break;
          }
        } else {
          var _item$widgetProps4;
          if ((_item$widgetProps4 = item.widgetProps) !== null && _item$widgetProps4 !== void 0 && _item$widgetProps4.defaultValue) {
            defaultForm[item.formCode] = item.widgetProps.defaultValue;
          }
        }
      };

      //处理时间类型
      newFormRows === null || newFormRows === void 0 || newFormRows.map(function (row) {
        row.cols.map(function (col) {
          col.items.map(function (item) {
            var _item$formCode;
            var dataId = (_item$formCode = item.formCode) === null || _item$formCode === void 0 ? void 0 : _item$formCode.split('@');
            if (!item.formCode) {
              return;
            }
            getFormData(item, row, dataId);
            if (item.groupItem) {
              getFormData(item.groupItem, row, dataId);
            }
          });
        });
      });
      form.setFieldsValue(defaultForm);
      setFormValue(defaultForm);
      setFormOption(_objectSpread(_objectSpread({}, formJson), {}, {
        rows: newFormRows
      }));
    } else {
      setFormOption(formJson ? formJson : null);
    }
  }, [formJson, formData]);
  var dateFormat = function dateFormat(dataType, value) {
    switch (dataType) {
      case 'RangePicker':
        try {
          var _value, _value2, _value3, _value4;
          value = "".concat((_value = value) !== null && _value !== void 0 && _value[0] ? (_value2 = value) === null || _value2 === void 0 ? void 0 : _value2[0].format('YYYY-MM-DD HH:mm:ss') : '', ",").concat((_value3 = value) !== null && _value3 !== void 0 && _value3[1] ? (_value4 = value) === null || _value4 === void 0 ? void 0 : _value4[1].format('YYYY-MM-DD HH:mm:ss') : '');
        } catch (error) {
          console.log(error);
        }
        break;
      case 'DatePicker':
        try {
          var _value5;
          value = value ? (_value5 = value) === null || _value5 === void 0 ? void 0 : _value5.format('YYYY-MM-DD HH:mm:ss') : '';
        } catch (error) {
          console.log(error);
        }
        break;
      case 'TimePicker':
        try {
          var _value6;
          value = value ? (_value6 = value) === null || _value6 === void 0 ? void 0 : _value6.format('HH:mm:ss') : '';
        } catch (error) {
          console.log(error);
        }
        break;
      case 'TimeRangePicker':
        try {
          var _value7, _value8, _value9, _value10;
          value = "".concat((_value7 = value) !== null && _value7 !== void 0 && _value7[0] ? (_value8 = value) === null || _value8 === void 0 ? void 0 : _value8[0].format('HH:mm:ss') : '', ",").concat((_value9 = value) !== null && _value9 !== void 0 && _value9[1] ? (_value10 = value) === null || _value10 === void 0 ? void 0 : _value10[1].format('HH:mm:ss') : '');
        } catch (error) {
          console.log(error);
        }
        break;
      default:
        break;
    }
    return value;
  };
  //对外接口
  useImperativeHandle(ref, function () {
    return {
      getFormOption: function getFormOption() {
        return formOption;
      },
      getFieldsData: function () {
        var _getFieldsData = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
          var _formJson$rows, _formJson$rows2;
          var vals, formValues, groupList;
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return form.validateFields();
              case 2:
                vals = _context.sent;
                formValues = {}; //获取设置了动态表单的按钮
                groupList = [];
                formJson === null || formJson === void 0 || (_formJson$rows = formJson.rows) === null || _formJson$rows === void 0 || _formJson$rows.forEach(function (row) {
                  var _row$cols2;
                  (_row$cols2 = row.cols) === null || _row$cols2 === void 0 || _row$cols2.forEach(function (col) {
                    var _col$items2;
                    (_col$items2 = col.items) === null || _col$items2 === void 0 || _col$items2.forEach(function (item) {
                      var _item$widgetProps5, _item$widgetProps6;
                      if (['Divider', 'XTitle'].includes(item.dataType) && (_item$widgetProps5 = item.widgetProps) !== null && _item$widgetProps5 !== void 0 && _item$widgetProps5.button && (_item$widgetProps6 = item.widgetProps) !== null && _item$widgetProps6 !== void 0 && _item$widgetProps6.groupKey) {
                        var _item$widgetProps7;
                        groupList.push((_item$widgetProps7 = item.widgetProps) === null || _item$widgetProps7 === void 0 ? void 0 : _item$widgetProps7.groupKey);
                      }
                    });
                  });
                });
                formJson === null || formJson === void 0 || (_formJson$rows2 = formJson.rows) === null || _formJson$rows2 === void 0 || _formJson$rows2.map(function (row) {
                  if (groupList.includes(row.rowId)) {
                    var cloneValueList = [];
                    var cloneRows = formOption === null || formOption === void 0 ? void 0 : formOption.rows.filter(function (obj) {
                      return obj.rowId.includes(row.rowId);
                    });
                    //查找复制列的组合
                    cloneRows === null || cloneRows === void 0 || cloneRows.map(function (cloneRow) {
                      var _cloneRow$cols;
                      var itemsValue = {};
                      (_cloneRow$cols = cloneRow.cols) === null || _cloneRow$cols === void 0 || _cloneRow$cols.map(function (col) {
                        col.items.map(function (item) {
                          if (item.isForm && item.formCode && !isNull(vals[item.itemId])) {
                            var _item$formCode2;
                            var value = vals[item.formCode];
                            if (!isEmpty(value)) {
                              value = dateFormat(item.dataType, value);
                            }
                            var dataId = (_item$formCode2 = item.formCode) === null || _item$formCode2 === void 0 ? void 0 : _item$formCode2.split('@');
                            itemsValue[dataId === null || dataId === void 0 ? void 0 : dataId[0]] = value;
                          }
                        });
                      });
                      cloneValueList.push(itemsValue);
                    });
                    formValues[row.rowId] = cloneValueList;
                  } else {
                    row.cols.map(function (col) {
                      col.items.map(function (item) {
                        if (item.isForm && item.formCode && !isNull(vals[item.itemId])) {
                          var _item$formCode3;
                          var value = vals[item.formCode];
                          if (!isEmpty(value)) {
                            value = dateFormat(item.dataType, value);
                          }
                          var dataId = (_item$formCode3 = item.formCode) === null || _item$formCode3 === void 0 ? void 0 : _item$formCode3.split('@');
                          formValues[dataId === null || dataId === void 0 ? void 0 : dataId[0]] = value;
                        }
                      });
                    });
                  }
                });
                return _context.abrupt("return", formValues);
              case 8:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }));
        function getFieldsData() {
          return _getFieldsData.apply(this, arguments);
        }
        return getFieldsData;
      }(),
      setFieldValue: function setFieldValue(name, value, widgetProps) {
        setFormValue(function (fValue) {
          if (widgetProps.multiple) {
            var oldVal = fValue[name] ? fValue[name].split(',') : [];
            oldVal.push(value);
            value = oldVal.join(',');
          }
          form.setFieldValue(name, value);
          return _objectSpread(_objectSpread({}, fValue), {}, _defineProperty({}, name, value));
        });
      },
      resetFields: function resetFields() {
        form.resetFields();
        setFormValue({});
      }
    };
  });

  //生成ID
  var getUninId = function getUninId(prefix) {
    var hash = new Date().valueOf().toString().substring(9) + ((1 + Math.random()) * 0x10000 | 0).toString(16).substring(1);
    if (prefix) {
      return "".concat(prefix, "_").concat(hash);
    }
    return hash;
  };
  //组合添加
  var addGroup = function addGroup(groupKey) {
    var newFormRows = cloneDeep(formOption === null || formOption === void 0 ? void 0 : formOption.rows);
    var cloneRow = newFormRows === null || newFormRows === void 0 ? void 0 : newFormRows.find(function (row) {
      return row.rowId === groupKey;
    });
    if (!cloneRow) {
      return;
    }
    //克隆行
    var newRow = cloneDeep(cloneRow);
    var cloneId = getUninId('clone');
    newRow.rowId = "".concat(groupKey, "@").concat(cloneId);
    newRow.rowType = 'clone';
    newRow.cols.map(function (col) {
      col.colId = "".concat(groupKey, "@").concat(col.colId, "@").concat(cloneId);
      col.items.map(function (item) {
        var itemId = "".concat(groupKey, "@").concat(item.itemId, "@").concat(cloneId);
        item.itemId = itemId;
        item.formCode = "".concat(item.formCode, "@").concat(cloneId);
      });
    });
    var index = findLastIndex(formOption === null || formOption === void 0 ? void 0 : formOption.rows, function (obj) {
      return obj.rowId.includes(groupKey);
    });
    newFormRows === null || newFormRows === void 0 || newFormRows.splice(index + 1, 0, newRow);
    setFormOption(_objectSpread(_objectSpread({}, formOption), {}, {
      rows: newFormRows
    }));
  };
  //组合移除
  var removeGroup = function removeGroup(rowId) {
    var _formOption$rows;
    var newFormRows = formOption === null || formOption === void 0 || (_formOption$rows = formOption.rows) === null || _formOption$rows === void 0 ? void 0 : _formOption$rows.filter(function (row) {
      return row.rowId !== rowId;
    });
    setFormOption(_objectSpread(_objectSpread({}, formOption), {}, {
      rows: newFormRows
    }));
  };
  var CreateFormItem = function CreateFormItem(item, col, formOption, dataSourceList, rowSpan) {
    var CreateWidget = function CreateWidget(widgetItem) {
      var _widgetItem$formCode, _widgetItem$widgetPro, _item$widgetProps8, _widgetItem$widgetPro2, _item$widgetProps10, _item$widgetProps12, _widgetItem$widgetPro3, _widgetItem$widgetPro4, _widgetItem$widgetPro5, _widgetItem$widgetPro6, _widgetItem$widgetPro7, _widgetItem$widgetPro8, _widgetItem$widgetPro9, _widgetItem$widgetPro10, _widgetItem$widgetPro11, _widgetItem$widgetPro12, _widgetItem$widgetPro13, _widgetItem$widgetPro14, _widgetItem$widgetPro15, _item$widgetProps13, _widgetItem$widgetPro16, _item$widgetProps14;
      var itemCode = (_widgetItem$formCode = widgetItem.formCode) === null || _widgetItem$formCode === void 0 ? void 0 : _widgetItem$formCode.split('@')[0];
      if (extraContent !== null && extraContent !== void 0 && extraContent[itemCode]) {
        return extraContent === null || extraContent === void 0 ? void 0 : extraContent[itemCode];
      }
      var options = ((_widgetItem$widgetPro = widgetItem.widgetProps) === null || _widgetItem$widgetPro === void 0 ? void 0 : _widgetItem$widgetPro.options) || [];
      if (dataSourceList !== null && dataSourceList !== void 0 && dataSourceList[widgetItem.dataClass] && widgetItem.queryType === 'api') {
        options = dataSourceList[widgetItem.dataClass];
      }
      var cloneItem = [];
      if (['Divider', 'XTitle'].includes(item.dataType) && (_item$widgetProps8 = item.widgetProps) !== null && _item$widgetProps8 !== void 0 && _item$widgetProps8.groupKey) {
        var _formOption$rows2;
        cloneItem = ((_formOption$rows2 = formOption.rows) === null || _formOption$rows2 === void 0 ? void 0 : _formOption$rows2.filter(function (row) {
          var _item$widgetProps9;
          return row.rowId.indexOf((_item$widgetProps9 = item.widgetProps) === null || _item$widgetProps9 === void 0 ? void 0 : _item$widgetProps9.groupKey) > -1 && row.rowType === 'clone';
        })) || [];
      }
      switch (widgetItem.dataType) {
        case 'Divider':
          return /*#__PURE__*/React.createElement("div", {
            style: _objectSpread(_objectSpread({
              padding: '0 8px'
            }, widgetItem.labelStyle), widgetItem.widgetProps)
          }, /*#__PURE__*/React.createElement(_Divider, null, /*#__PURE__*/React.createElement("span", {
            style: _objectSpread({}, widgetItem.labelStyle)
          }, widgetItem.formName)), !readOnly && ((_widgetItem$widgetPro2 = widgetItem.widgetProps) === null || _widgetItem$widgetPro2 === void 0 ? void 0 : _widgetItem$widgetPro2.button) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
            style: {
              position: 'absolute',
              right: '44px',
              top: '0px',
              zIndex: 2
            },
            size: (item === null || item === void 0 || (_item$widgetProps10 = item.widgetProps) === null || _item$widgetProps10 === void 0 ? void 0 : _item$widgetProps10.buttonSize) || 'default',
            type: "primary",
            ghost: true,
            icon: /*#__PURE__*/React.createElement(PlusOutlined, null),
            onClick: function onClick() {
              var _item$widgetProps11;
              return addGroup((_item$widgetProps11 = item.widgetProps) === null || _item$widgetProps11 === void 0 ? void 0 : _item$widgetProps11.groupKey);
            }
          }), /*#__PURE__*/React.createElement(_Button, {
            size: (item === null || item === void 0 || (_item$widgetProps12 = item.widgetProps) === null || _item$widgetProps12 === void 0 ? void 0 : _item$widgetProps12.buttonSize) || 'default',
            disabled: cloneItem.length === 0,
            style: {
              position: 'absolute',
              right: '8px',
              top: '0px',
              zIndex: 2
            },
            type: "primary",
            ghost: true,
            icon: /*#__PURE__*/React.createElement(MinusOutlined, null),
            onClick: function onClick() {
              var _cloneItem;
              return removeGroup((_cloneItem = cloneItem[cloneItem.length - 1]) === null || _cloneItem === void 0 ? void 0 : _cloneItem.rowId);
            }
          })));
        case 'Input':
          return /*#__PURE__*/React.createElement(_Input, _extends({}, widgetItem.widgetProps, {
            disabled: readOnly
          }));
        case 'InputNumber':
          return /*#__PURE__*/React.createElement(_InputNumber, _extends({
            min: 0
          }, widgetItem.widgetProps, {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro3 = widgetItem.widgetProps) === null || _widgetItem$widgetPro3 === void 0 ? void 0 : _widgetItem$widgetPro3.style),
            disabled: readOnly
          }));
        case 'Checkbox':
          return /*#__PURE__*/React.createElement(_Checkbox.Group, _extends({}, widgetItem.widgetProps, {
            options: options,
            disabled: readOnly
          }));
        case 'Text':
          return /*#__PURE__*/React.createElement("div", {
            style: _objectSpread({}, (_widgetItem$widgetPro4 = widgetItem.widgetProps) === null || _widgetItem$widgetPro4 === void 0 ? void 0 : _widgetItem$widgetPro4.style)
          }, " ", widgetItem.widgetContent, " ");
        case 'Select':
          return /*#__PURE__*/React.createElement(_Select, _extends({}, widgetItem.widgetProps, {
            options: options,
            disabled: readOnly
          }));
        case 'Radio':
          return /*#__PURE__*/React.createElement(_Radio.Group, _extends({}, widgetItem.widgetProps, {
            options: options,
            disabled: readOnly
          }));
        case 'RangePicker':
          return /*#__PURE__*/React.createElement(_DatePicker.RangePicker, _extends({}, widgetItem.widgetProps, {
            disabled: readOnly
          }));
        case 'TextArea':
          return /*#__PURE__*/React.createElement(_Input.TextArea, _extends({}, widgetItem.widgetProps, {
            disabled: readOnly
          }));
        case 'Rate':
          return /*#__PURE__*/React.createElement("div", {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro5 = widgetItem.widgetProps) === null || _widgetItem$widgetPro5 === void 0 ? void 0 : _widgetItem$widgetPro5.style)
          }, /*#__PURE__*/React.createElement(_Rate, _extends({}, omit(widgetItem.widgetProps, ['style']), {
            style: {
              lineHeight: 'normal'
            },
            disabled: readOnly
          })));
        case 'Switch':
          return /*#__PURE__*/React.createElement("div", {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro6 = widgetItem.widgetProps) === null || _widgetItem$widgetPro6 === void 0 ? void 0 : _widgetItem$widgetPro6.style)
          }, /*#__PURE__*/React.createElement(_Switch, _extends({}, omit(widgetItem.widgetProps, ['style']), {
            disabled: readOnly
          })));
        case 'Slider':
          return /*#__PURE__*/React.createElement(_Slider, _extends({}, widgetItem.widgetProps, {
            disabled: readOnly
          }));
        case 'ColorPicker':
          return /*#__PURE__*/React.createElement(_ColorPicker, _extends({}, widgetItem.widgetProps, {
            disabled: readOnly
          }));
        case 'DatePicker':
          return /*#__PURE__*/React.createElement(_DatePicker, _extends({}, widgetItem.widgetProps, {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro7 = widgetItem.widgetProps) === null || _widgetItem$widgetPro7 === void 0 ? void 0 : _widgetItem$widgetPro7.style),
            disabled: readOnly
          }));
        case 'TimePicker':
          return /*#__PURE__*/React.createElement(_TimePicker, _extends({}, widgetItem.widgetProps, {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro8 = widgetItem.widgetProps) === null || _widgetItem$widgetPro8 === void 0 ? void 0 : _widgetItem$widgetPro8.style),
            disabled: readOnly
          }));
        case 'TimeRangePicker':
          return /*#__PURE__*/React.createElement(_TimePicker.RangePicker, _extends({}, widgetItem.widgetProps, {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro9 = widgetItem.widgetProps) === null || _widgetItem$widgetPro9 === void 0 ? void 0 : _widgetItem$widgetPro9.style),
            disabled: readOnly
          }));
        case 'TreeSelect':
          var treeData = [];
          var groupObj = groupBy(options, widgetItem.groupField);
          for (var key in groupObj) {
            treeData.push({
              title: key,
              value: key,
              disabled: true,
              children: groupObj[key].map(function (obj) {
                return {
                  title: obj.label,
                  value: obj.value
                };
              })
            });
          }
          return /*#__PURE__*/React.createElement(_TreeSelect, _extends({
            showSearch: true,
            treeDefaultExpandAll: true
          }, widgetItem.widgetProps, {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro10 = widgetItem.widgetProps) === null || _widgetItem$widgetPro10 === void 0 ? void 0 : _widgetItem$widgetPro10.style),
            treeData: treeData
          }));
        case 'Cascader':
          return /*#__PURE__*/React.createElement(_Cascader, _extends({}, widgetItem.widgetProps, {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro11 = widgetItem.widgetProps) === null || _widgetItem$widgetPro11 === void 0 ? void 0 : _widgetItem$widgetPro11.style),
            options: provincesData2Options()
          }));
        case 'Password':
          return /*#__PURE__*/React.createElement(_Input.Password, _extends({}, widgetItem.widgetProps, {
            disabled: readOnly
          }));
        case 'Upload':
          var dataValue = formValue[item.formCode];
          if (readOnly) {
            return dataValue ? /*#__PURE__*/React.createElement(_Row, {
              gutter: [8, 8]
            }, dataValue === null || dataValue === void 0 ? void 0 : dataValue.split(',').map(function (urlStr, i) {
              var _urlStr$split;
              // 提取 HTTPS URL 的文件扩展名
              var fileExtension = (urlStr === null || urlStr === void 0 || (_urlStr$split = urlStr.split('.')) === null || _urlStr$split === void 0 || (_urlStr$split = _urlStr$split.pop()) === null || _urlStr$split === void 0 ? void 0 : _urlStr$split.toLowerCase()) || '';
              return /*#__PURE__*/React.createElement(_Col, {
                span: 6
              }, ['jpeg', 'jpg', 'png', 'gif'].includes(fileExtension) ? /*#__PURE__*/React.createElement(_Image, {
                width: '100%',
                height: '98%',
                src: "".concat(fileBaseUrl + urlStr),
                alt: "\u6682\u65E0\u56FE\u7247",
                style: {
                  minWidth: '90%',
                  maxWidth: '100%',
                  minHeight: '98%'
                }
              }) : /*#__PURE__*/React.createElement("a", {
                href: "".concat(fileBaseUrl + urlStr),
                download: "file"
              }, "\u6587\u4EF6\u9700\u4E0B\u8F7D\u5230\u672C\u5730\u8FDB\u884C\u9884\u89C8\uFF0C\u70B9\u51FB\u4E0B\u8F7D"));
            })) : '暂无数据';
          }
          var fileList = dataValue ? dataValue === null || dataValue === void 0 ? void 0 : dataValue.split(',').map(function (urlStr, i) {
            return {
              uid: i,
              name: "image".concat(i + 1, ".png"),
              status: 'done',
              url: fileBaseUrl + urlStr
            };
          }) : [];
          return /*#__PURE__*/React.createElement("div", {
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro12 = widgetItem.widgetProps) === null || _widgetItem$widgetPro12 === void 0 ? void 0 : _widgetItem$widgetPro12.style)
          }, /*#__PURE__*/React.createElement(_Input, {
            id: item.itemId + '_input',
            style: {
              display: 'none'
            }
          }), /*#__PURE__*/React.createElement(_Upload, _extends({}, item.widgetProps, {
            fileList: fileList,
            onPreview: function onPreview(file) {
              if (file.url) {
                setPreviewImage(file.url);
              }
            },
            onRemove: function onRemove(file) {
              var _file$url;
              var url = last((_file$url = file.url) === null || _file$url === void 0 ? void 0 : _file$url.split('/')) || '';
              if (url) {
                setFormValue(function (fValue) {
                  var value = fValue[item.formCode].split(',').filter(function (str) {
                    return !str.includes(url);
                  });
                  form.setFieldValue(item.formCode, value.join(','));
                  return _objectSpread(_objectSpread({}, fValue), {}, _defineProperty({}, item.formCode, value.join(',')));
                });
              }
            },
            customRequest: function customRequest(file) {
              return onUpload === null || onUpload === void 0 ? void 0 : onUpload(item, file);
            }
          }), /*#__PURE__*/React.createElement(_Button, {
            style: {
              border: 0,
              background: 'none'
            },
            type: "text",
            icon: /*#__PURE__*/React.createElement(UploadOutlined, null)
          }, "\u9009\u62E9\u6587\u4EF6")));
        case 'ImgUpload':
          var imgItemData = formValue[item.formCode];
          return /*#__PURE__*/React.createElement("div", {
            className: "imgUploadCotent",
            style: _objectSpread({
              width: '100%'
            }, (_widgetItem$widgetPro13 = widgetItem.widgetProps) === null || _widgetItem$widgetPro13 === void 0 ? void 0 : _widgetItem$widgetPro13.style)
          }, /*#__PURE__*/React.createElement("div", {
            className: "imgUpload ".concat(imgItemData ? 'imgPanel' : ''),
            style: {
              width: ((_widgetItem$widgetPro14 = widgetItem.widgetProps) === null || _widgetItem$widgetPro14 === void 0 ? void 0 : _widgetItem$widgetPro14.width) || 200,
              height: ((_widgetItem$widgetPro15 = widgetItem.widgetProps) === null || _widgetItem$widgetPro15 === void 0 ? void 0 : _widgetItem$widgetPro15.height) || 250
            }
          }, /*#__PURE__*/React.createElement("div", {
            className: "B_leftTop"
          }), /*#__PURE__*/React.createElement("div", {
            className: "B_leftBottom"
          }), /*#__PURE__*/React.createElement("div", {
            className: "B_rightTop"
          }), /*#__PURE__*/React.createElement("div", {
            className: "B_rightBottom"
          }), imgItemData && /*#__PURE__*/React.createElement(_Image, {
            width: '100%',
            height: '100%',
            src: "".concat(fileBaseUrl + imgItemData),
            alt: "\u6682\u65E0\u56FE\u7247",
            style: {
              minWidth: '90%',
              maxWidth: '100%',
              minHeight: '100%'
            }
          }), !readOnly && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Input, {
            id: item.itemId + '_input',
            style: {
              display: 'none'
            }
          }), /*#__PURE__*/React.createElement(_Upload, {
            showUploadList: false,
            accept: (_item$widgetProps13 = item.widgetProps) === null || _item$widgetProps13 === void 0 ? void 0 : _item$widgetProps13.accept,
            customRequest: function customRequest(file) {
              return onUpload === null || onUpload === void 0 ? void 0 : onUpload(item, file);
            }
          }, /*#__PURE__*/React.createElement("div", {
            className: "imgUploadBtn"
          }, /*#__PURE__*/React.createElement(UploadOutlined, null))))));
        //嵌套行 不做
        case 'Row':
          return /*#__PURE__*/React.createElement(React.Fragment, null);
        case 'XTitle':
          return /*#__PURE__*/React.createElement("div", {
            id: widgetItem.itemId,
            style: _objectSpread(_objectSpread({
              padding: '0 8px'
            }, widgetItem.labelStyle), widgetItem.widgetProps)
          }, /*#__PURE__*/React.createElement(XTitle, {
            title: /*#__PURE__*/React.createElement("p", {
              style: _objectSpread({}, widgetItem.labelStyle)
            }, widgetItem.formName),
            right: !readOnly && ((_widgetItem$widgetPro16 = widgetItem.widgetProps) === null || _widgetItem$widgetPro16 === void 0 ? void 0 : _widgetItem$widgetPro16.button) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
              style: {
                position: 'absolute',
                right: '32px',
                zIndex: 2
              },
              size: (item === null || item === void 0 || (_item$widgetProps14 = item.widgetProps) === null || _item$widgetProps14 === void 0 ? void 0 : _item$widgetProps14.buttonSize) || 'default',
              type: "primary",
              ghost: true,
              icon: /*#__PURE__*/React.createElement(PlusOutlined, null),
              onClick: function onClick() {
                var _item$widgetProps15;
                return addGroup((_item$widgetProps15 = item.widgetProps) === null || _item$widgetProps15 === void 0 ? void 0 : _item$widgetProps15.groupKey);
              }
            }), /*#__PURE__*/React.createElement(_Button, {
              disabled: cloneItem.length === 0,
              style: {
                position: 'absolute',
                right: '0px',
                zIndex: 2
              },
              type: "primary",
              ghost: true,
              icon: /*#__PURE__*/React.createElement(MinusOutlined, null),
              onClick: function onClick() {
                var _cloneItem2;
                return removeGroup((_cloneItem2 = cloneItem[cloneItem.length - 1]) === null || _cloneItem2 === void 0 ? void 0 : _cloneItem2.rowId);
              }
            }))
          }));
        default:
          break;
      }
    };
    var labelStyle = item.labelStyle ? _objectSpread({}, item.labelStyle) : {};
    if (formOption !== null && formOption !== void 0 && formOption.layout.labelWrap) {
      labelStyle.whiteSpace = 'break-spaces';
    }

    //二级行才有的属性，行宽
    var colSpan = col.span;
    if (rowSpan) {
      colSpan = colSpan * (rowSpan / 24);
    }
    var labelSpan = round(((formOption === null || formOption === void 0 ? void 0 : formOption.layout.labelCol) || 3) * (24 / colSpan));
    if (item !== null && item !== void 0 && item.isForm) {
      var _item$groupItem;
      if ((_item$groupItem = item.groupItem) !== null && _item$groupItem !== void 0 && _item$groupItem.itemId) {
        var _formOption$rows3, _item$formName, _item$rules, _item$groupItem3;
        var connectItem = item.groupItem;
        (_formOption$rows3 = formOption.rows) === null || _formOption$rows3 === void 0 || _formOption$rows3.map(function (row, i) {
          if (isEmpty(connectItem)) {
            var _row$cols3;
            (_row$cols3 = row.cols) === null || _row$cols3 === void 0 || _row$cols3.forEach(function (col) {
              var obj = col.items.find(function (obj) {
                var _item$groupItem2;
                return obj.itemId === ((_item$groupItem2 = item.groupItem) === null || _item$groupItem2 === void 0 ? void 0 : _item$groupItem2.itemId);
              });
              if (obj) {
                connectItem = obj;
              }
            });
          }
        });
        return /*#__PURE__*/React.createElement(_Form.Item, {
          colon: false,
          label: item !== null && item !== void 0 && item.labelHide ? '' : /*#__PURE__*/React.createElement("div", {
            className: "customLabel",
            style: labelStyle
          }, item.formName, (_item$formName = item.formName) !== null && _item$formName !== void 0 && _item$formName.includes(connectItem.formName) ? '' : "/".concat(connectItem.formName)),
          labelCol: {
            span: labelSpan
          },
          className: (_item$rules = item.rules) !== null && _item$rules !== void 0 && (_item$rules = _item$rules[0]) !== null && _item$rules !== void 0 && _item$rules.required ? 'itemRequired' : ''
        }, /*#__PURE__*/React.createElement(_Flex, {
          style: {
            alignItems: 'center'
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            width: 'calc(50% - 5px)'
          }
        }, /*#__PURE__*/React.createElement(_Form.Item, {
          colon: false,
          name: item.formCode,
          label: '',
          rules: item.rules
        }, CreateWidget(item))), /*#__PURE__*/React.createElement("div", {
          style: {
            width: '10px',
            textAlign: 'center'
          }
        }, (_item$groupItem3 = item.groupItem) === null || _item$groupItem3 === void 0 ? void 0 : _item$groupItem3.connector), /*#__PURE__*/React.createElement("div", {
          style: {
            width: 'calc(50% - 5px)'
          }
        }, /*#__PURE__*/React.createElement(_Form.Item, {
          colon: false,
          name: connectItem.formCode,
          label: '',
          rules: connectItem.rules
        }, CreateWidget(connectItem)))));
      }
      return /*#__PURE__*/React.createElement(_Form.Item, {
        colon: false,
        name: item.formCode,
        label: item !== null && item !== void 0 && item.labelHide ? '' : /*#__PURE__*/React.createElement("div", {
          className: "customLabel",
          style: labelStyle
        }, item.formName),
        labelCol: {
          span: labelSpan
        },
        rules: item.rules
      }, CreateWidget(item));
    } else {
      return /*#__PURE__*/React.createElement("div", null, CreateWidget(item), " ");
    }
  };
  var CreateRow = function CreateRow(rows) {
    return rows === null || rows === void 0 ? void 0 : rows.map(function (row, i) {
      var _row$cols4;
      return /*#__PURE__*/React.createElement(_Row, {
        gutter: [6, (formOption === null || formOption === void 0 ? void 0 : formOption.layout.verticalGap) || 6],
        key: row.rowId,
        className: "row",
        style: _objectSpread(_objectSpread({}, row.style), {}, {
          marginBottom: i + 1 == rows.length ? 0 : ((formOption === null || formOption === void 0 ? void 0 : formOption.layout.verticalGap) || 8) + 'px'
        })
      }, row.rowType === 'clone' && /*#__PURE__*/React.createElement(_Divider, {
        style: {
          margin: 0
        },
        variant: "dashed",
        dashed: true
      }), (_row$cols4 = row.cols) === null || _row$cols4 === void 0 ? void 0 : _row$cols4.map(function (col) {
        var items = col.items;
        return /*#__PURE__*/React.createElement(_Col, {
          key: col.colId,
          span: col.span
        }, !isEmpty(col.rows) && CreateRow(col.rows), items === null || items === void 0 ? void 0 : items.map(function (item, i) {
          return /*#__PURE__*/React.createElement("div", {
            key: item.itemId,
            className: "widget",
            style: i < items.length - 1 ? {
              marginBottom: (formOption === null || formOption === void 0 ? void 0 : formOption.layout.verticalGap) || 6
            } : {}
          }, CreateFormItem(item, col, formOption, dataSourceEnum, row.rowSpan));
        }));
      }));
    });
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "formViewContent ".concat((formOption === null || formOption === void 0 || (_formOption$layout = formOption.layout) === null || _formOption$layout === void 0 ? void 0 : _formOption$layout.type) === 'fixed' ? 'designFixed' : ''),
    style: _objectSpread({
      width: (formOption === null || formOption === void 0 || (_formOption$layout2 = formOption.layout) === null || _formOption$layout2 === void 0 ? void 0 : _formOption$layout2.type) === 'fixed' ? ((_formOption$layout3 = formOption.layout) === null || _formOption$layout3 === void 0 ? void 0 : _formOption$layout3.widthPercent) + '%' || '900px' : '100%'
    }, formOption === null || formOption === void 0 || (_formOption$layout4 = formOption.layout) === null || _formOption$layout4 === void 0 ? void 0 : _formOption$layout4.style)
  }, /*#__PURE__*/React.createElement(_ConfigProvider, XAntdConfig, /*#__PURE__*/React.createElement(_Form, {
    size: formOption === null || formOption === void 0 || (_formOption$layout5 = formOption.layout) === null || _formOption$layout5 === void 0 ? void 0 : _formOption$layout5.size,
    layout: (formOption === null || formOption === void 0 || (_formOption$layout6 = formOption.layout) === null || _formOption$layout6 === void 0 ? void 0 : _formOption$layout6.labelLayout) || 'horizontal',
    form: form,
    labelWrap: formOption === null || formOption === void 0 || (_formOption$layout7 = formOption.layout) === null || _formOption$layout7 === void 0 ? void 0 : _formOption$layout7.labelWrap,
    requiredMark: formOption === null || formOption === void 0 || (_formOption$layout8 = formOption.layout) === null || _formOption$layout8 === void 0 ? void 0 : _formOption$layout8.requiredMark,
    labelAlign: (formOption === null || formOption === void 0 || (_formOption$layout9 = formOption.layout) === null || _formOption$layout9 === void 0 ? void 0 : _formOption$layout9.labelAlign) || 'right',
    disabled: !!readOnly,
    onValuesChange: onValuesChange
  }, (formOption === null || formOption === void 0 ? void 0 : formOption.rows) && CreateRow(formOption === null || formOption === void 0 ? void 0 : formOption.rows))), previewImage && /*#__PURE__*/React.createElement(_Image, {
    wrapperStyle: {
      display: 'none'
    },
    preview: {
      visible: !!previewImage,
      onVisibleChange: function onVisibleChange(visible) {
        return setPreviewImage('');
      },
      afterOpenChange: function afterOpenChange(visible) {
        return !visible && setPreviewImage('');
      }
    },
    src: previewImage
  }));
}
export default /*#__PURE__*/React.forwardRef(XFormView);