/// <reference types="react" />
export declare class IXFormRef {
    /**
     * 获取表单数据
     **/
    getFieldsData: () => void;
    /**
     *获取表单设置项目
     */
    getFormOption: () => void;
    /**
     *设置表单内容
     */
    setFieldValue: (name: string, value: any) => void;
    /**
     * 重置表单
     */
    resetFields: () => void;
}
export declare interface IFormOptions {
    layout: {
        type: 'fixed' | 'auto';
        width?: number;
        widthPercent?: number;
        labelLayout?: 'horizontal' | 'vertical';
        size?: 'large' | 'middle';
        style?: React.CSSProperties;
        verticalGap?: number;
        showRowNum?: boolean;
        /**
         * 标签所占列数
         */
        labelCol?: number;
        /**
         * 标签是否允许换行
         */
        labelWrap?: boolean;
        requiredMark?: boolean | 'optional';
        labelAlign?: 'left' | 'right';
    };
    rows: IRowOPtions[];
    dataLink?: [];
}
export declare interface IRowOPtions {
    rowId: string;
    rowType?: string;
    rowSpan?: number;
    verticalGap?: number;
    cols: IColOptions[];
    style?: React.CSSProperties;
}
export declare interface IColOptions {
    span: number;
    colId: string;
    items: IFormItemOptions[];
    rows?: IRowOPtions[];
}
export declare interface IFormItemOptions {
    formName?: string;
    formCname?: string;
    itemId: string;
    formCode: string;
    isForm: boolean;
    label?: string;
    labelHide?: boolean;
    dataType: any;
    dataClass: any;
    watchItem?: string;
    /**标签占据列数 */
    labelCols?: number;
    labelStyle?: React.CSSProperties;
    rules?: rules[];
    /**非表单组件时的内容 */
    widgetContent?: any;
    widgetProps?: any;
    queryType?: any;
    groupItem?: IFormGroupItemOptions;
    groupField?: any;
}
declare interface rules {
    required?: boolean;
    message?: string;
}
declare interface IFormGroupItemOptions extends IFormItemOptions {
    connector: string;
}
export {};
