import _Button from "antd/es/button";
import _message from "antd/es/message";
import _notification from "antd/es/notification";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _Progress from "antd/es/progress";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _Modal from "antd/es/modal";
/*
 * @Author: chenzenghua
 * @Date: 2024-05-13 21:45:54
 * @LastEditTime: 2024-05-14 16:52:44
 * @LastEditors: chenzenghua
 * @Description:
 */
import "./styles.less";
import { useEffect, useState } from 'react';
import { XDraggableModal } from '..';
import React from 'react';
import { CheckCircleFilled, CloseCircleFilled, InfoCircleFilled } from '@ant-design/icons';
var _confirm = _Modal.confirm;
var progressStatus = {
  info: 'active',
  success: 'success',
  error: 'exception',
  warn: 'normal',
  warning: 'normal'
};
var MsgProgress = function MsgProgress(_ref) {
  var duration = _ref.duration,
    type = _ref.type;
  var _useState = useState(100),
    _useState2 = _slicedToArray(_useState, 2),
    percent = _useState2[0],
    setPercent = _useState2[1];
  var intervalID;
  //分50步
  var step = 50;
  useEffect(function () {
    //-500是去除渲染用时
    var time = (duration * 1000 - 500) / step;
    var stepNum = 100 / step;
    intervalID && clearInterval(intervalID);
    intervalID = setInterval(function () {
      setPercent(function (per) {
        if (per <= stepNum) {
          clearInterval(intervalID);
        }
        return per > stepNum ? per - stepNum : 0;
      });
    }, time);
  }, []);
  return /*#__PURE__*/React.createElement(_Progress, {
    style: {
      height: 2
    },
    status: progressStatus[type],
    className: "msgProgress",
    percent: percent,
    size: "small",
    strokeColor: type.indexOf('warn') > -1 ? '#FAAD13' : '',
    showInfo: false
  });
};
var showMsg = function showMsg(type, content, config) {
  var width = 400;
  if (typeof content === 'string') {
    width = content.length * 14 + 100;
  }
  if (width > 800) {
    width = 800;
  }
  if (width < 150) {
    width = 150;
  }
  if (config !== null && config !== void 0 && config.description) {
    width = 500;
  }
  var duration = 3;
  if ((config === null || config === void 0 ? void 0 : config.duration) !== undefined) {
    duration = config === null || config === void 0 ? void 0 : config.duration;
  }
  var configMerge = _objectSpread(_objectSpread({
    placement: 'top',
    duration: duration,
    message: /*#__PURE__*/React.createElement("div", null, content, (config === null || config === void 0 ? void 0 : config.showProgress) !== false && duration > 0 && /*#__PURE__*/React.createElement(MsgProgress, {
      type: type,
      duration: duration
    })),
    style: {
      width: width
    },
    closable: true
  }, config), {}, {
    showProgress: false,
    // config?.showProgress === false ? false : true,
    className: "x-messagebox x-messagebox-".concat(type, " ").concat((config === null || config === void 0 ? void 0 : config.className) || '')
  });

  //兼容老配置
  //@ts-ignore
  if ((config === null || config === void 0 ? void 0 : config.autoClose) === false) {
    configMerge.duration = 0;
  }
  return _notification[type](configMerge);
};
var msg = {
  info: function info(content, config) {
    return showMsg('info', content, config);
  },
  success: function success(content, config) {
    return showMsg('success', content, config);
  },
  error: function error(content, config) {
    return showMsg('error', content, config);
  },
  warn: function warn(content, config) {
    return showMsg('warning', content, config);
  },
  warning: function warning(content, config) {
    return showMsg('warning', content, config);
  },
  loading: function loading() {
    var content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Loading...';
    var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'loading';
    var config = arguments.length > 2 ? arguments[2] : undefined;
    var configMerge = _objectSpread({
      content: content,
      key: key
    }, {
      config: config
    });
    return _message.loading(configMerge);
  },
  confirm: function confirm(content, config) {
    var p = new Promise(function (resolve, reject) {
      var Icon;
      switch ((config === null || config === void 0 ? void 0 : config.type) || 'info') {
        case 'info':
          Icon = /*#__PURE__*/React.createElement(InfoCircleFilled, {
            style: {
              fontSize: '16px',
              color: '#3d79ff',
              marginRight: '3px'
            }
          });
          break;
        case 'error':
          Icon = /*#__PURE__*/React.createElement(CloseCircleFilled, {
            style: {
              fontSize: '16px',
              color: '#e93b3c',
              marginRight: '3px'
            }
          });
          break;
        case 'success':
          Icon = /*#__PURE__*/React.createElement(CheckCircleFilled, {
            style: {
              fontSize: '16px',
              color: '#39b41e',
              marginRight: '3px'
            }
          });
          break;
        case 'warn':
          Icon = /*#__PURE__*/React.createElement(InfoCircleFilled, {
            style: {
              fontSize: '16px',
              color: '#f47b00',
              marginRight: '3px'
            }
          });
          break;
        default:
          break;
      }
      var modal = _confirm({
        transitionName: '',
        modalRender: function modalRender() {
          return /*#__PURE__*/React.createElement(XDraggableModal, {
            hideDefaultTitleIcon: true,
            className: "xinherc-confim-box",
            maskClosable: false,
            title: /*#__PURE__*/React.createElement("div", {
              style: {
                fontSize: '15px',
                display: 'flex',
                alignItems: 'center'
              }
            }, Icon, (config === null || config === void 0 ? void 0 : config.title) || '请确认'),
            width: (config === null || config === void 0 ? void 0 : config.width) || 330,
            onCancel: function onCancel() {
              return modal.destroy();
            },
            children: /*#__PURE__*/React.createElement("div", {
              style: {
                padding: '12px 20px'
              }
            }, content),
            open: true,
            footer: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
              type: "primary",
              ghost: true,
              key: "cancel",
              onClick: function onClick() {
                reject('cancel');
                modal.destroy();
              },
              className: "x-btn-confirm"
            }, "\u53D6\u6D88"), /*#__PURE__*/React.createElement(_Button, {
              type: "primary",
              key: "ok",
              className: "x-btn-confirm",
              onClick: function onClick() {
                resolve('ok');
                modal.destroy();
              }
            }, "\u786E\u5B9A"))
          });
        }
      });
    });
    return p;
  }
};
export default msg;