import _ConfigProvider from "antd/es/config-provider";
import _Menu from "antd/es/menu";
import _extends from "@babel/runtime/helpers/esm/extends";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _Layout from "antd/es/layout";
import AutoScrollWrapper from "../components/AutoScrollWrapper";
import { RightOutlined } from '@ant-design/icons';
import { useUpdateEffect } from 'ahooks';
import React, { useCallback, useState } from 'react';
import "./styles.less";
import { StyleProvider } from '@ant-design/cssinjs';
var Sider = _Layout.Sider;
var XNavMenu = function XNavMenu(props) {
  var _useState = useState(props.defaultCollapsed || props.defaultCollapased ? true : props.collapsed || props.collapased),
    _useState2 = _slicedToArray(_useState, 2),
    collapsed = _useState2[0],
    setCollapsed = _useState2[1];
  var _useState3 = useState(1000),
    _useState4 = _slicedToArray(_useState3, 2),
    refreshFlag = _useState4[0],
    setRefreshFlag = _useState4[1];
  var popLevel3 = function popLevel3(e) {
    e.domEvent.currentTarget.onclick = function (e) {
      //阻止原本的菜单展开行为
      e.stopPropagation();
      e.preventDefault();
    };

    //var offsetX = event.clientX - elementRect.left
    var controlId = e.domEvent.currentTarget.getAttribute('aria-controls');
    var element = document.querySelector("#".concat(controlId));
    if (!element) {
      console.log('未找到子菜单元素');
      return;
    }

    //清空已有
    var refreshEle = document.querySelectorAll('.level3popup');
    refreshEle === null || refreshEle === void 0 || refreshEle.forEach(function (item) {
      item.classList.remove('level3popup');
    });

    //hack样式
    element.parentNode.classList.add('ant-menu-submenu-open');
    element.classList.add('level3popup');
    element.parentNode.classList.remove('ant-menu-hidden');
    element.style.left = "".concat(e.domEvent.currentTarget.getBoundingClientRect().right, "px");
    element.style.top = "".concat(e.domEvent.currentTarget.getBoundingClientRect().top, "px");
  };
  var createMenu = useCallback(function () {
    if (props.level3MenuMode === 'popup') {
      if (props.menus) {
        props.menus.forEach(function (l1) {
          if (l1 !== null && l1 !== void 0 && l1.children) {
            l1.children.forEach(function (l2) {
              if (l2.children) {
                //有三级菜单
                l2.onTitleMouseEnter = function (e) {
                  popLevel3(e);
                };
                l2.expandIcon = /*#__PURE__*/React.createElement(RightOutlined, {
                  className: "l3popicon"
                });
              }
            });
          }
        });
      }
    }
    return props.menus;
  }, [props.menus, collapsed]);
  useUpdateEffect(function () {
    setCollapsed(props.collapsed);
  }, [props.collapsed]);
  useUpdateEffect(function () {
    setCollapsed(props.collapased);
  }, [props.collapased]);
  useUpdateEffect(function () {
    //重新渲染
    setRefreshFlag(refreshFlag + 1);
  }, [props.level3MenuMode]);
  var handleMenuClick = function handleMenuClick(_ref) {
    var _props$onMenuClick;
    var key = _ref.key,
      keyPath = _ref.keyPath;
    console.log(keyPath);
    var menu;
    if (keyPath.length === 1) {
      menu = [].concat(_toConsumableArray(props.menus), _toConsumableArray(props.bottomMenus || [])).find(function (p) {
        return (p === null || p === void 0 ? void 0 : p.key) === key;
      });
    } else {
      var paths = keyPath.reverse();
      // 第一层
      var m = props.menus.find(function (p1) {
        return (p1 === null || p1 === void 0 ? void 0 : p1.key) === paths[0];
      });
      paths.forEach(function (k1, index) {
        if (index > 0) {
          var _m;
          //@ts-ignore
          m = (_m = m) === null || _m === void 0 || (_m = _m.children) === null || _m === void 0 ? void 0 : _m.find(function (sub) {
            return sub.key === k1;
          });
        }
      });
      menu = m;
    }
    (_props$onMenuClick = props.onMenuClick) === null || _props$onMenuClick === void 0 || _props$onMenuClick.call(props, menu, key, keyPath);
  };
  return /*#__PURE__*/React.createElement(StyleProvider, {
    hashPriority: "high"
  }, /*#__PURE__*/React.createElement(_ConfigProvider, {
    theme: {
      token: {
        borderRadius: 2
      },
      components: {
        Menu: {
          iconSize: 18,
          collapsedWidth: 50
        }
      }
    }
  }, /*#__PURE__*/React.createElement(_Layout, {
    className: "xinhe-xnavmenu",
    onMouseLeave: function onMouseLeave() {
      if (props.level3MenuMode === 'popup') {
        var refreshEle = document.querySelectorAll('.level3popup');
        refreshEle === null || refreshEle === void 0 || refreshEle.forEach(function (item) {
          item.classList.remove('level3popup');
        });
      }
    },
    key: "x-menu-".concat(refreshFlag)
  }, /*#__PURE__*/React.createElement(Sider, {
    className: "nav nav".concat(props.theme || 'dark'),
    collapsible: true,
    collapsedWidth: "50px",
    collapsed: collapsed,
    onCollapse: function onCollapse(c) {
      var _props$onCollapasedCh, _props$onCollapsedCha;
      setCollapsed(c);
      (_props$onCollapasedCh = props.onCollapasedChange) === null || _props$onCollapasedCh === void 0 || _props$onCollapasedCh.call(props, c);
      (_props$onCollapsedCha = props.onCollapsedChange) === null || _props$onCollapsedCha === void 0 || _props$onCollapsedCha.call(props, c);
    },
    trigger: props.hideTrigger ? null : undefined
  }, props.collapsedLogo && collapsed && /*#__PURE__*/React.createElement("div", {
    className: "logoWrapper"
  }, props.collapsedLogo), (props.expandedLogo || props.collapsedLogo) && !collapsed && /*#__PURE__*/React.createElement("div", {
    className: "logoWrapper ".concat(props.hideTopLogo ? 'hide-logo' : '')
  }, props.expandedLogo || props.collapsedLogo), /*#__PURE__*/React.createElement("div", {
    className: "menuWrapper",
    style: {
      flex: '1 1'
    }
  }, /*#__PURE__*/React.createElement(AutoScrollWrapper, null, /*#__PURE__*/React.createElement(_Menu, _extends({
    inlineIndent: 12,
    forceSubMenuRender: props.level3MenuMode === 'popup',
    onClick: handleMenuClick,
    defaultSelectedKeys: props.defaultSelectedKeys,
    selectedKeys: props.selectedKeys,
    subMenuCloseDelay: 0.3,
    mode: "inline"
    //onMouseOver={(e) => console.log(e)}
    ,
    theme: props.theme || 'dark',
    items: createMenu()
  }, props.menuProps)))), props.bottomMenus && /*#__PURE__*/React.createElement("div", {
    className: "menuWrapper",
    style: {
      flex: '0 0',
      height: "".concat(props.bottomMenuHeight || '100px')
    }
  }, /*#__PURE__*/React.createElement(AutoScrollWrapper, null, /*#__PURE__*/React.createElement(_Menu, {
    inlineIndent: 12,
    forceSubMenuRender: props.level3MenuMode === 'popup',
    onClick: handleMenuClick,
    defaultSelectedKeys: props.defaultSelectedKeys,
    selectedKeys: props.selectedKeys,
    subMenuCloseDelay: 0.3,
    mode: "inline"
    //onMouseOver={(e) => console.log(e)}
    ,
    theme: props.theme || 'dark',
    items: props.bottomMenus
  })))))));
};
export default XNavMenu;