import _ConfigProvider from "antd/es/config-provider";
import _Select from "antd/es/select";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _Spin from "antd/es/spin";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useDebounceFn } from 'ahooks';
import React, { useImperativeHandle, useCallback, useEffect, useMemo, useState, useRef } from 'react';
import { isEmpty, cloneDeep, isEqual } from 'lodash';
import { XAntdConfig, XDataGrid } from '..';
import "./styles.less";
import { StyleProvider, legacyLogicalPropertiesTransformer } from '@ant-design/cssinjs';
function Index(props, ref) {
  var _props$defaultValue5;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    gridApi = _useState4[0],
    setGridApi = _useState4[1];
  var _useState5 = useState(),
    _useState6 = _slicedToArray(_useState5, 2),
    selectRow = _useState6[0],
    setSelectRow = _useState6[1];
  var _useState7 = useState(),
    _useState8 = _slicedToArray(_useState7, 2),
    inputRow = _useState8[0],
    setInputRow = _useState8[1];
  var lockXSelectDrop = useRef(null);
  var firstFlag = useRef(null);
  useEffect(function () {
    if (!props.valueRow) {
      console.log('必须传入valueRow');
    }
  }, []);
  useEffect(function () {
    if (props.defaultValue) {
      var _props$defaultValue, _props$defaultValue2;
      firstFlag.current = true;
      var selectList = (_props$defaultValue = props.defaultValue) === null || _props$defaultValue === void 0 ? void 0 : _props$defaultValue.filter(function (obj) {
        return !obj.isInput;
      });
      var inputList = (_props$defaultValue2 = props.defaultValue) === null || _props$defaultValue2 === void 0 ? void 0 : _props$defaultValue2.filter(function (obj) {
        return obj.isInput;
      });
      setSelectRow(selectList);
      setInputRow(inputList);
    }
  }, [props.defaultValue]);
  console.log(selectRow);
  useEffect(function () {
    if (firstFlag.current) {
      firstFlag.current = false;
      return;
    }
    if (selectRow || inputRow) {
      var _props$defaultValue3, _props$defaultValue4;
      var selectList = (_props$defaultValue3 = props.defaultValue) === null || _props$defaultValue3 === void 0 ? void 0 : _props$defaultValue3.filter(function (obj) {
        return !obj.isInput;
      });
      var inputList = (_props$defaultValue4 = props.defaultValue) === null || _props$defaultValue4 === void 0 ? void 0 : _props$defaultValue4.filter(function (obj) {
        return obj.isInput;
      });
      if (!isEqual(selectList, selectRow) || !isEqual(inputList, inputRow)) {
        var _props$onSelectChange;
        (_props$onSelectChange = props.onSelectChange) === null || _props$onSelectChange === void 0 || _props$onSelectChange.call(props, [].concat(_toConsumableArray(selectRow || []), _toConsumableArray(inputRow || [])));
      }
    }
  }, [selectRow, inputRow]);
  var memoDropdownRender = useMemo(function () {
    return /*#__PURE__*/React.createElement("div", {
      className: "xinherc-xselector-dropdowntable",
      onClick: function onClick(e) {
        e.stopPropagation();
        e.preventDefault();
      },
      onMouseUp: function onMouseUp(e) {
        lockXSelectDrop.current = true;
        setTimeout(function () {
          lockXSelectDrop.current = false;
        }, 500);
      }
    }, props.data && /*#__PURE__*/React.createElement(XDataGrid
    //@ts-ignore
    , {
      rowID: props.valueRow,
      autoFitWith: true,
      showRowNumberCol: true,
      rowSelection: props.mode === 'multiple' ? 'multiple' : 'single',
      showSelectionCol: true,
      loading: !props.data,
      columnDefs: props.colDef,
      data: props.data,
      disableExportBtn: true,
      disableSideBarToggle: true,
      disableFullScreen: true,
      hideStatusBar: true,
      onSelectionChanged: function onSelectionChanged(selectRows) {
        setSelectRow(function (row) {
          var _row$, _selectRows$;
          if (props.mode !== 'multiple' && (row === null || row === void 0 || (_row$ = row[0]) === null || _row$ === void 0 ? void 0 : _row$[props.valueRow]) !== (selectRows === null || selectRows === void 0 || (_selectRows$ = selectRows[0]) === null || _selectRows$ === void 0 ? void 0 : _selectRows$[props.valueRow])) {
            var _props$onDropdownOpen;
            setOpen(false);
            (_props$onDropdownOpen = props.onDropdownOpen) === null || _props$onDropdownOpen === void 0 || _props$onDropdownOpen.call(props, false);
          }
          return selectRows;
        });
      },
      onGridReady: function onGridReady(ga) {
        return setGridApi(ga);
      },
      selectedRows: selectRow,
      gridOptions: props.gridOptions,
      StatusBarExtra: props.statusBarExtra
    }) || /*#__PURE__*/React.createElement(_Spin, null));
  }, [props.data, props.colDef, selectRow]);
  //对外接口
  useImperativeHandle(ref, function () {
    return {
      gridApi: gridApi,
      setValue: function setValue(selects, inputs) {
        setSelectRow(selects);
        setInputRow(inputs);
      },
      getValue: function getValue() {
        return getSelectValue();
      },
      clearValue: function clearValue() {
        setSelectRow([]);
        setInputRow([]);
      }
    };
  });

  //获取选择与输入添加组合的值
  var getSelectValue = useCallback(function () {
    var arr = [];
    var value = [].concat(_toConsumableArray(selectRow || []), _toConsumableArray(inputRow || []));
    value === null || value === void 0 || value.forEach(function (item) {
      arr.push({
        label: item[props.nameRow],
        value: item[props.valueRow]
      });
    });
    return arr;
  }, [selectRow, inputRow, props.nameRow, props.valueRow]);
  var triggerChange = useDebounceFn(function (e) {
    gridApi === null || gridApi === void 0 || gridApi.setQuickFilter(e);
  }, {
    wait: 300
  }).run;
  var handleKeyDown = function handleKeyDown(e) {
    if (e.key === 'Enter') {
      var _props$data;
      var value = e.target.value;
      // 这里编写回车事件的处理逻辑
      var selectlist = cloneDeep(selectRow) || [];
      var inputlist = cloneDeep(inputRow) || [];
      var x = (_props$data = props.data) === null || _props$data === void 0 ? void 0 : _props$data.find(function (p) {
        return p.VALUE_ID === value || p.VALUE_NAME === value;
      });
      if (x) {
        //选择添加
        setSelectRow([].concat(_toConsumableArray(selectlist), [x]));
      } else {
        //手动添加
        setInputRow([].concat(_toConsumableArray(inputlist), [_defineProperty(_defineProperty(_defineProperty({}, props.valueRow, value), props.nameRow, value), "isInput", '1')]));
        e.target.blur();
        e.target.focus();
      }
    }
  };
  return /*#__PURE__*/React.createElement(StyleProvider, {
    transformers: [legacyLogicalPropertiesTransformer],
    hashPriority: "high"
  }, /*#__PURE__*/React.createElement(_ConfigProvider, XAntdConfig, /*#__PURE__*/React.createElement("div", {
    className: "xinherc-xselector"
  }, !isEmpty(props.data) ? /*#__PURE__*/React.createElement(_Select, {
    onKeyDown: props.enterAdd ? handleKeyDown : undefined,
    onOpenChange: function onOpenChange(e) {
      var _props$onDropdownOpen2;
      if (lockXSelectDrop.current) return;
      setOpen(e);
      (_props$onDropdownOpen2 = props.onDropdownOpen) === null || _props$onDropdownOpen2 === void 0 || _props$onDropdownOpen2.call(props, e);
      gridApi === null || gridApi === void 0 || gridApi.setQuickFilter();
    },
    onSearch: function onSearch(e) {
      triggerChange(e);
    },
    onClick: props.onClick,
    open: open,
    mode: props.mode,
    maxTagCount: props.maxTagCount,
    allowClear: props.allowClear,
    showSearch: true,
    popupMatchSelectWidth: props.popupMatchSelectWidth,
    onDeselect: function onDeselect(e) {
      setSelectRow(selectRow === null || selectRow === void 0 ? void 0 : selectRow.filter(function (p) {
        return p[props.valueRow] !== e.value;
      }));
      setInputRow(inputRow === null || inputRow === void 0 ? void 0 : inputRow.filter(function (p) {
        return p[props.valueRow] !== e.value;
      }));
    },
    dropdownStyle: _objectSpread({}, props.dropdownStyle)
    // onMouseDown={(e) => e.preventDefault()}
    ,
    onClear: function onClear() {
      setSelectRow([]);
      setInputRow([]);
    },
    labelInValue: true,
    style: _objectSpread({
      width: '100%'
    }, props.style),
    placeholder: props.placeholder || '请选择'
    // defaultValue={selectRow}
    ,
    value: getSelectValue(),
    popupClassName: "xinherc-selector-dropdown",
    popupRender: function popupRender() {
      return memoDropdownRender;
    },
    disabled: props.disabled
  }) : /*#__PURE__*/React.createElement(_Select, {
    onKeyDown: props.enterAdd ? handleKeyDown : undefined,
    options: props.defaultValue,
    value: (_props$defaultValue5 = props.defaultValue) === null || _props$defaultValue5 === void 0 ? void 0 : _props$defaultValue5.map(function (obj) {
      return {
        key: obj.VALUE_ID
      };
    }),
    fieldNames: {
      value: 'VALUE_ID',
      label: 'VALUE_NAME'
    }
    //@ts-ignore
    ,
    mode: props.mode,
    maxTagCount: props.maxTagCount,
    allowClear: props.allowClear,
    showSearch: true,
    dropdownStyle: _objectSpread({}, props.dropdownStyle),
    labelInValue: true,
    style: _objectSpread({
      width: '100%'
    }, props.style),
    placeholder: props.placeholder || '请选择',
    popupClassName: "xinherc-selector-dropdown",
    disabled: props.disabled,
    onSelect: function onSelect(e) {
      console.log(e);
    },
    onClear: function onClear() {
      setSelectRow([]);
      setInputRow([]);
    }
  }))));
}
export default /*#__PURE__*/React.forwardRef(Index);