/**
 * 检查更新 Hook
 * 用于检测应用是否有新版本可用
 */
export interface UseCheckForUpdatesParams {
    /** dev 环境无需检查更新 */
    dev: boolean;
    /** 检查更新的 URL，默认为当前域名 */
    url?: string;
    /** 检查间隔时间（毫秒），默认 30 秒 */
    interval?: number;
    /** 是否自动开始检查，默认 true */
    autoStart?: boolean;
    /** 发现更新时的回调函数，返回 false，自定义更新逻辑 */
    onUpdateFound?: (newHash: string, oldHash: string) => boolean | void;
    /** 检查失败时的回调函数 */
    onError?: (error: Error) => void;
}
export declare const useCheckForUpdates: (params?: UseCheckForUpdatesParams) => {
    startCheck: () => void;
    stopCheck: () => void;
};
